
#

#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
  #portions of this code are modifications of examples from Google
  # Copyright 2005-2007, Google, Inc.
  # 
  # Name :        K2_ToolsBoxJoint.rb  ###
  # Date :	      July 2014
  # Version :     2.1.0
  # Author :      Keith Krueger (with a big help from plugin forum)
  #
 
require 'sketchup.rb'
require 'K2WS_Tools/k2ws_module.rb' #-NameSpace Module


module K²WS

class K2_BoxFingers
	
	def initialize
		@mod = Sketchup.active_model
    @sel = @mod.selection
    @labelText = "Dovetail PIN Dimensions"
    @opt_LEN_No = Sketchup.active_model.options["UnitsOptions"]["LengthUnit"]
    @opt_Format_No = Sketchup.active_model.options["UnitsOptions"]["LengthFormat"]
    @opt_Precision_No = Sketchup.active_model.options["UnitsOptions"]["LengthPrecision"]
    @ans=Array.new
    #Test for Acceptable Units/Format and Set rnd_Factor
    @rnd_Factor = 0
    if @opt_LEN_No == 0 && @opt_Format_No == 0 then @rnd_Factor = 10**-(1*@opt_Precision_No) end
    if @opt_LEN_No == 0 && @opt_Format_No == 3 then @rnd_Factor = 0.015625 * 2**(6 - @opt_Precision_No) end
    if @opt_LEN_No == 2 && @opt_Format_No == 0 then @rnd_Factor = 0.0393701 * 10**-(1*@opt_Precision_No) end
    if @rnd_Factor == 0
      UI.messagebox("Units must be Inches or Millimeters \n Fromat must be Decimal or Fractions \n \n CHANGE UNITS & RE-SELECT TOOL ")
      Sketchup.send_action "selectSelectionTool:"
    else
      #Debug UI.messagebox("@rnd_Factor = " + @rnd_Factor.to_s)
    end #if @rnd_Factor
		@ip = Sketchup::InputPoint.new
		@inpt = Sketchup::InputPoint.new		
		@tinpt= Sketchup::InputPoint.new
    @ans=Array.new
		@file =  __FILE__.gsub(/.rb$/,'.txt')
		if !(FileTest.exist?(@file)) 
        f = File.new(@file, "w+") 
        f.close
        self.reset
      else
        self.reset
        self.read_data
      end # FileTest
	end # initialize
	
	def reset
		@best = nil; @comp = nil; @sel.clear; @status = 0; @drawn = false
		
	end
	
	def read_data
		# Read an array of Input Data from the file 
		# open input data file in read mode	       
		f = File.open(@file, "r")    
		@ans = f.readlines
    #strip end of line or file from all data
    @ans = @ans.collect { |data|
      data.strip 
    }
		# Close the file
		f.close		
	end # read_data
	
	def write_data
		# Write an array of Input Data to the file
		# open input data file in write mode	       
		f = File.open(@file, "w")
		f.puts @ans
		# Close the file
		f.close
	end
	
	def readExistingData
		self.read_data
		
		@opt = @ans[0] == "Space"
		@typ = @ans[0];  @opt =  @typ == "Space"
    @spc = @ans[1].to_l
    @fng = @ans[2].to_l
    @qty = @ans[3].to_i
    @edge1_Last = @ans[7].to_l
		@edge2_Last = @ans[8].to_l
    
	end #readExistingData
  
  def same_Joint
      begin
        @edge1_Last = @ans[7].to_l; @edge2_Last = @ans[8].to_l
      rescue
        @edge1_Last = 0; @edge2_Last = 0
        #Debug UI.messagebox("blank data error rescued")
      end
     if @e_len1 == @edge1_Last && @e_len2 == @edge2_Last
        result = UI.messagebox('Use Existing Box Joint Data ???', MB_YESNO)
        if result == 6 
          @use_ExistingData = "Yes" # @use_ExistingData is not Saved (Secesion only data)
        else
          @use_ExistingData = "No"  # @use_ExistingData is not Saved (Secesion only data)
        end # if result
      else
        @use_ExistingData = "No"  # @use_ExistingData is not Saved (Secesion only data)
      end # if @e_len1
      @ans[7] = @e_len1.to_s;  @ans[8] = @e_len2.to_s
      self.write_data
      #Debug UI.messagebox("use_ExistingData = " + @use_ExistingData.to_s)
    end # same_Joint

	def dialog
		# open a file in read mode	       
		self.read_data
		prompts = ["Joint Face READ ONLY  ","       Thickness:","      Length:"]
		defaults= [@e_len2.to_s + " x " + @e_len1.to_s,@ans[1].to_s,@ans[2].to_s]
		choices = ["","","",""]  
		results = inputbox prompts, defaults, choices, "Input Data Box Joint Fingers/Spaces"
		if !results then;Sketchup.send_action "selectSelectionTool:";return;end
		@spc = results[1].to_l; @ans[1] = results[1]
		@fng = results[2].to_l; @ans[2] = results[2]
    @qty = @e_len1/@spc;  @ans[3] = @qty
		
		# Write an array of Input Data to the file
		self.write_data
	end
  
  def select_Start
    prompts = ["Start Joint With: "]
		defaults= [@ans[0]]
		choices = ["Space|Finger"]  
		results = inputbox prompts, defaults, choices, "Input Data Box Joint Fingers/Spaces"
		if !results then;Sketchup.send_action "selectSelectionTool:";return;end
    @opt = @ans[0] == "Space"
		@typ = results[0]; @ans[0] = results[0]; @opt =  @typ == "Space"
    
    # Write an array of Input Data to the file
		self.write_data
    
  end # select_Start

	def onMouseMove(flags, x, y, view)
		Sketchup::set_status_text("Select Component to get Box Joint Fingers:    [SPACE BAR] to Exit", SB_PROMPT) if @status==0 
    Sketchup::set_status_text("Select Component to Hide :   [SPACE BAR] to Exit", SB_PROMPT) if @status==1
		Sketchup::set_status_text("Select Outside Width Edge on Component:   [SPACE BAR] to Exit",SB_PROMPT) if @status==2
		Sketchup::set_status_text("Select Top Thickness Edge on Component:   [SPACE BAR] to Exit",SB_PROMPT) if @status==3
		Sketchup::set_status_text("Width,Length:", SB_VCB_LABEL)
		Sketchup::set_status_text("#{@spc},#{@fng}", SB_VCB_VALUE)
		@ip.pick view,x,y
		view.tooltip = @ip.tooltip     
		view.refresh
	end


  	def onLButtonDown(flags, x, y, view)
		if @status==0 #select 1st component
			ph=view.pick_helper; ph.do_pick x,y; @comp1=ph.best_picked
			if @comp1 && (@comp1.is_a?(Sketchup::ComponentInstance))
				@sel.add(@comp1); @ent1=@comp1.definition.entities; @status=1
				onMouseMove(flags, x, y, view)
			else
				UI.messagebox "Selection invalid, must be component"
			end #@comp1
    
      elsif @status==1	#select 2nd component
        ph=view.pick_helper; ph.do_pick x,y; @comp2=ph.best_picked
        if @comp2 && (@comp2.is_a?(Sketchup::ComponentInstance))
          @sel.add(@comp2); @ent2=@comp2.definition.entities; @status=2
          @tform2 = @comp2.transformation.inverse
          onMouseMove(flags, x, y, view)
          @sel.clear; @entity=@comp1; @sel.add(@comp1); @comp2.hidden=true
        else
          UI.messagebox "Selection invalid, must be component"
        end #@entity	    
      
      
		elsif @status==2 #select long edge, width
			@ip.pick view,x,y
			if(@ip.valid?)
				if(@ip.edge && @ent1.include?(@ip.edge))
					@edge1 = @ip.edge; @e_len1=@edge1.length 
					@status = 3
					onMouseMove(flags, x, y, view)
				else
				  UI.messagebox"Other Component is Interfering with pick: Use Right Button Click and Hide before Continuing!"
				  self.reset
				end
			end
		elsif @status==3 #select short edge, thickness 
			@ip.pick view,x,y
			if(@ip.valid?)
				if(@ip.edge && @ent1.include?(@ip.edge))
					@edge2 = @ip.edge;  @e_len2=@edge2.length 
          
          #Data Input Section
          self.same_Joint
          if @use_ExistingData == "No"
            self.dialog
          else
            begin
              self.readExistingData
            rescue
              UI.messagebox("Problem reading data! ReEnter Data")
              self.dialog
            end # begin
          end # if @use_ExistingData
          #Always Select Start With  Finger/Space
          self.select_Start
          
					@mod.start_operation "Box Joint"
					wid = @edge1.length; hgt = @edge2.length; @fng = hgt if @fng==0
					#p2 = @ip.position; p2.transform! @tr2; edge=@ip.edge; pt,x2=edge.line
					#(pt = edge.end.position; x2.reverse!) if pt.distance(p2) > @ip.edge.length/2
					p0 = Geom.intersect_line_line(@edge1.line,@edge2.line)
					p1,x1=@edge1.line; x1.reverse! if p0 != p1
					p1,ya=@edge2.line; ya.reverse! if p0 != p1
					for i in 0...@qty  #(wid/@spc).floor
						p1a=p0.offset(ya,hgt); #p1b=pt.offset(ya,hgt)
						p2a=p1a.offset(x1,@spc); #p2b=p1b.offset(x2,@spc)
						p3a=p0.offset(x1,@spc); #p3b=pt.offset(x2,@spc)
						if @opt
							face= @ent1.add_face(p0,p1a,p2a,p3a)
							face.pushpull -@fng
						end
						p0=p3a;  @opt = !@opt
					end
					@mod.commit_operation
          @comp2.hidden=false
					self.reset
          Sketchup.send_action "selectSelectionTool:"
				else
					UI.beep
				end
			end
		end
	end #def onLButtonDown
	
	def onRButtonDown(flags,x,y,view)
		self.reset
		self.dialog
	end
		
	def onCancel(flag, view)
		view.refresh if @drawn
		Sketchup.send_action "selectSelectionTool:"
	end

	def draw(view)
		@drawn = false
		if( @ip.valid? && @ip.display? )
			@ip.draw(view)
			@drawn = true
		end
	end
	
end # of class K2_BoxFingers

end #module



#-----------------------------------------------------------------------------
file_loaded("KK_BoxJointTool.rb") 
