
#

#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
  #portions of this code are modifications of examples from Google
  # Copyright 2005-2007, Google, Inc.
  # 
  # Name :        K2_ToolsDovetail.rb ###
  # Date :	      July 2014
  # Version :     2.1.0
  #
  #
  # Author :       Keith Krueger  (with a big help from plugin forum)
  #

require 'sketchup.rb'
require 'K2WS_Tools/k2ws_module.rb' #-NameSpace Module


module K²WS
class K2_DovetailPins
		
	def initialize
		@mod = Sketchup.active_model
    @sel = @mod.selection
    @labelText = "Dovetail PIN Dimensions"
    @opt_LEN_No = Sketchup.active_model.options["UnitsOptions"]["LengthUnit"]
    @opt_Format_No = Sketchup.active_model.options["UnitsOptions"]["LengthFormat"]
    @opt_Precision_No = Sketchup.active_model.options["UnitsOptions"]["LengthPrecision"]
    @ans=Array.new
    #Test for Acceptable Units/Format and Set rnd_Factor
    @rnd_Factor = 0
    if @opt_LEN_No == 0 && @opt_Format_No == 0 then @rnd_Factor = 10**-(1*@opt_Precision_No) end
    if @opt_LEN_No == 0 && @opt_Format_No == 3 then @rnd_Factor = 0.015625 * 2**(6 - @opt_Precision_No) end
    if @opt_LEN_No == 2 && @opt_Format_No == 0 then @rnd_Factor = 0.0393701 * 10**-(1*@opt_Precision_No) end
    if @rnd_Factor == 0
      UI.messagebox("Units must be Inches or Millimeters \n Fromat must be Decimal or Fractions \n \n CHANGE UNITS & RE-SELECT TOOL ")
      Sketchup.send_action "selectSelectionTool:"
    else
      #Debug UI.messagebox("@rnd_Factor = " + @rnd_Factor.to_s)
    end #if @rnd_Factor
		@ip = Sketchup::InputPoint.new
		@inpt = Sketchup::InputPoint.new		
		@tinpt= Sketchup::InputPoint.new
    @ans=Array.new
		@file =  __FILE__.gsub(/.rb$/,'.txt')
		if !(FileTest.exist?(@file)) 
        f = File.new(@file, "w+") 
        f.close
        self.reset
      else
        self.reset
        self.read_data
      end # FileTest
	end # initialize
	
	def reset
		@best = nil; @comp = nil; @sel.clear; @status = 0 ; @drawn = false
    #Debug UI.messagebox("status = " + @status.to_s)
	end
	
	def read_data
		# Read an array of Input Data from the file 
		# open input data file in read mode	       
		f = File.open(@file, "r")    
		@ans = f.readlines
    #strip end of line or file from all data
    @ans = @ans.collect { |data|
      data.strip 
    }
		# Close the file
		f.close		
	end # read_data
	
	def write_data
		# Write an array of Input Data to the file
		# open input data file in write mode	       
		f = File.open(@file, "w")
		f.puts @ans
		# Close the file
		f.close
	end # write_data
	
	def readExistingData
		self.read_data
		
		@spc = @ans[0].to_s
		@ang = @ans[1].to_f 
      if @spc == "Degree" then	@rise = Math.tan(@ang.degrees) end
      if @spc == "Slope" then	@rise = @ang end
		@hpt = @ans[2].to_l 
		@fpt = @ans[3].to_l 
    @p_depth = @ans[4].to_l
		@spacing = @ans[5].to_s
    @quanity = @ans[6].to_i
    @edge1_Last = @ans[7].to_l
    @edge2_Last = @ans[8].to_l
		@p_length = @ans[9].to_l
      if @p_length == @edge2_Last  then  @apply_cleanUP = "No" end
      if @p_length < @edge2_Last  then  @apply_cleanUP = "Yes" end
    #ans[10..11]Open  
      
		self.no_of_Offset_Input
		n = @noOffsets
		@cl_offset=Array.new n
		i = 1
		i2 = 2
		while n > 0
			@cl_offset[i-1] = @ans[12+i].to_l
             
			n = n-1
			i = i+1
			i2 = i2+1		
		end #while n > 0	
	end #readExistingData
  
  def same_Joint
      begin
        @edge1_Last = @ans[7].to_l; @edge2_Last = @ans[8].to_l
      rescue
        @edge1_Last = 0; @edge2_Last = 0
        #Debug UI.messagebox("blank data error rescued")
      end
     if @e_len1 == @edge1_Last && @e_len2 == @edge2_Last
        result = UI.messagebox('Use Existing Dovetail Joint Data ???', MB_YESNO)
        if result == 6 
          @use_ExistingData = "Yes" # @use_ExistingData is not Saved (Secesion only data)
        else
          @use_ExistingData = "No"  # @use_ExistingData is not Saved (Secesion only data)
        end # if result
      else
        @use_ExistingData = "No"  # @use_ExistingData is not Saved (Secesion only data)
      end # if @e_len1
      @ans[7] = @e_len1.to_s;  @ans[8] = @e_len2.to_s
      self.write_data
      #Debug UI.messagebox("use_ExistingData = " + @use_ExistingData.to_s)
    end # same_Joint
	
	def data_Input
		# open a file in read mode
		self.read_data
		prompts = ["Joint Face READ ONLY  ","Angle Units","Angle","End / Half Pin T @ Root","FullPin T @ Root","Pin Length","Pin Depth (Tail Bd T) ","Quanity","Spacing"]
		defaults= [@e_len2.to_s + " x " + @e_len1.to_s,@ans[0],@ans[1].to_s,@ans[2].to_s,@ans[3].to_s,@ans[9].to_s,@ans[4].to_s,@ans[6].to_s,@ans[5]]
		choices = ["","Degree|Slope","","","","","","","Auto|Symmetrical|User|Fixed"]	 
		results = inputbox prompts, defaults, choices, @labelText
		if !results then;Sketchup.send_action "selectSelectionTool:";return;end
		
		@spc=results[1]; @ans[0] = results[1]
    @ang=results[2].to_f; @ans[1] = results[2]
      if @spc == "Degree" then	@rise = Math.tan(@ang.degrees) end
      if @spc == "Slope" then	@rise = @ang end
    @hpt=results[3].to_l; @ans[2] = results[3]
    @fpt=results[4].to_l; @ans[3] = results[4]
    @p_length = results[5].to_l; @ans[9] = results[5]
      if @p_length == @e_len2  then  @apply_cleanUP = "No" end
      if @p_length < @e_len2  then  @apply_cleanUP = "Yes" end
    @p_depth=results[6].to_l; @ans[4] = results[6]
    @quanity=results[7].to_i; @ans[6] = results[7]
		@spacing=results[8]; @ans[5] = results[8]
    
		# Write an array of Input Data to the file
		self.write_data
		
	end #data_Input
	
	def no_of_Offset_Input
    #Debug    UI.messagebox("Spacing = " + @spacing)
		case @spacing
			when "Symmetrical"
				if @quanity <= 3
					@noOffsets=0
				else	 
					@noOffsets=(@quanity - 2)/2
				end #if @quanity <= 3		
			when "Auto"
				@noOffsets=0
			when "User"
				@noOffsets=@quanity - 1
			when "Fixed"
				@noOffsets=1
		end #case @spacing
    #Debug    UI.messagebox("noOffsets = " + @noOffsets.to_s)
	end #no_of_offsets
  
  def round_to(num)
    #Debug      UI.messagebox("origional no =  " + num.to_s)
    num_R = ((num + (@rnd_Factor/2.0))/@rnd_Factor).to_i*@rnd_Factor
    num_R = num_R.to_l
    #Debug      UI.messagebox("rounded no =  " + num_R.to_s)
    return num_R
  end #round_to  
		
	def round_3places(n)	
		n=(n*1000).to_i
		n=n.to_f/1000		
	end # round_3places
	
	def input_Offsets
		# open a file in read mode	       
		self.read_data
		n = @noOffsets
		@cl_offset=Array.new n
		i = 1
		i2 = 2    
    space = round_to(@e_len1 - (@hpt/2))
    if @spacing == "Symmetrical" then space = space/2 end
		while n > 0
			prompts = ["CL Distance Pin " + i.to_s + " to Pin " + i2.to_s + " ","Remaining Space for Pins   READ ONLY  ","Number Spaces   READ ONLY  " ]
			defaults= [@ans[12+i].to_s,space.to_s,n.to_s]               
			results = inputbox prompts, defaults, "Input CL Distance between Pins"
      @cl_offset[i-1]=results[0].to_l; @ans[12+i] = results[0]
      space = round_to(space - @cl_offset[i-1])           
			n = n-1
			i = i+1
			i2 = i2+1		
		end #while n > 0
		# Write an array of Input Data to the file
		self.write_data      
	end #def input_Offsets 
	
	def cal_xCL_points(x1,e_len)
		@xcl=Array.new @quanity
		case @spacing
			when "Symmetrical"
				#Debug UI.messagebox("Spacing = " + @spacing.to_s)
				if @quanity == 1
					@xcl[0]=x1+(@hpt-(@fpt/2))
					#Debug UI.messagebox("@xcl[0] = " + @xcl[0].to_s)
					#Debug UI.messagebox("Completed Quanity = " + @quanity.to_s)
				elsif @quanity == 2
					@xcl[0]=x1+(@hpt-(@fpt/2))
					@xcl[1]=x1+e_len-((@fpt/2)-@hpt)
					#Debug UI.messagebox("Completed Quanity = " + @quanity.to_s)		
				elsif @quanity == 3
					@xcl[0]=x1+(@hpt-(@fpt/2))			
					@xcl[1]=x1+(e_len/2)
					@xcl[2]=x1+e_len-(@hpt-(@fpt/2))
					#Debug UI.messagebox("Completed Quanity = " + @quanity.to_s)
				elsif @quanity >= 4
					#Calculate First, Last, Middle
					@xcl[0]=x1+(@hpt-(@fpt/2))
					@xcl[@quanity-1]=x1+e_len-(@hpt-(@fpt/2))
					@xcl[@quanity/2]=x1+(e_len/2)
					# Loop for the remaining CL
					n =(@quanity-2)/2	#loop number
					sn = 1 #Starting number
					i = 0
					while n > 0
						temp_offset=@cl_offset[i]
						@xcl[sn]=@xcl[sn-1]+(temp_offset)
						@xcl[@quanity-1-sn]=@xcl[@quanity-sn]-(temp_offset)
						sn = sn + 1
						n = n -1
						i = i + 1
					end # while n > 0				
				end #if @quanity ==
				#Debug @xcl.each {|e| UI.messagebox("Symmetrical CL point = "+ e.to_s)}			
			when "Auto"
				#Debug UI.messagebox("Case Spacing = " + @spacing.to_s)
				equal_offset=(e_len-(@hpt-(@fpt/2)))/(@quanity-1)
				@xcl[0]=x1+(@hpt-(@fpt/2))
				@xcl[@quanity-1]=x1+(e_len-(@hpt-(@fpt/2)))
				n =(@quanity-2)	#loop number
				sn = 1 #Starting number
				while n > 0
					@xcl[sn]=@xcl[sn-1]+(equal_offset)
					sn = sn + 1
					n = n -1
				end # while n > 0
				#Debug @xcl.each {|e| UI.messagebox("Equal CL point = "+ e.to_s)}		
			when "User"
				#Debug UI.messagebox("Case Spacing = " + @spacing.to_s)
				@xcl[0]=x1+(@hpt-(@fpt/2))
				n =(@quanity-1)	#loop number
				sn = 1 #Starting number
				i = 0
				while n > 0
					user_offset=@cl_offset[i]
					user_offset=user_offset.to_l
					#Debug UI.messagebox("user_offset = "+ user_offset.to_s)
					@xcl[sn]=@xcl[sn-1]+(user_offset)
					sn = sn + 1
					i = i + 1
					n = n -1
				end # while n > 0
				#Debug @xcl.each {|e| UI.messagebox("User CL point = "+ e.to_s)} 
			when "Fixed"
				#Debug UI.messagebox("Case Spacing = " + @spacing.to_s)
				@xcl[0]=x1+(@hpt-(@fpt/2))
				n =(@quanity-1)	#loop number
				sn = 1 #Starting number
				while n > 0
					fixed_offset=@cl_offset[0]
					@xcl[sn]=@xcl[sn-1]+fixed_offset
					sn = sn + 1
					n = n -1
				end # while n > 0
				#Debug @xcl.each {|e| UI.messagebox("Fixed CL point = "+ e.to_s)}		 
		end #case @spacing
	end #cal_xCL_points
		

	def onMouseMove(flags, x, y, view)
		Sketchup::set_status_text("SELECT PIN Board Component:   RIGHT CLICK to Change Data:   [SPACE BAR] to Exit", SB_PROMPT) if @status==0
    Sketchup::set_status_text("Select Tail Board Component Program will Hide :   [SPACE BAR] to Exit", SB_PROMPT) if @status==1 
		Sketchup::set_status_text("SELECT OUTSIDE WIDTH EDGE on End of PIN Board Component:   [SPACE BAR] to Exit",SB_PROMPT) if @status==2
		Sketchup::set_status_text("Select TOP THICKNESS EDGE on End of PIN Board Component:   [SPACE BAR] to Exit",SB_PROMPT) if @status==3
		@ip.pick view,x,y
		view.tooltip = @ip.tooltip	 
		view.refresh
	end # onMouseMove
	
	def onLButtonDown(flags, x, y, view)
		if @status==0 #select 1st component
			ph=view.pick_helper; ph.do_pick x,y; @comp1=ph.best_picked
			if @comp1 && (@comp1.is_a?(Sketchup::ComponentInstance))
				@sel.add(@comp1); @ent1=@comp1.definition.entities; @status=1
				onMouseMove(flags, x, y, view)
        @status = 1
			else
				UI.messagebox "Selection invalid, must be component"
			end #@comp1
		elsif @status==1	#select 2nd component
			ph=view.pick_helper; ph.do_pick x,y; @comp2=ph.best_picked
			if @comp2 && (@comp2.is_a?(Sketchup::ComponentInstance))
				@sel.add(@comp2); @ent2=@comp2.definition.entities;  @status=2
				@tform2 = @comp2.transformation.inverse
				onMouseMove(flags, x, y, view)
				@sel.clear; @entity=@comp1; @sel.add(@comp1); @comp2.hidden=true
        @status = 2
			else
				UI.messagebox "Selection invalid, must be component"
			end #@entity	
		elsif @status==2 #select long edge, width
			@ip.pick view,x,y
			if(@ip.valid?)
				if(@ip.edge && @ent1.include?(@ip.edge))
					@edge1 = @ip.edge; @e_len1=@edge1.length
					@status = 3
					onMouseMove(flags, x, y, view)
				else
					UI.messagebox"Other Component is Interfering with pick: Use Right Button Click and Hide before Continuing!"
					self.reset
				end
			end
		elsif @status==3 #select short edge, thickness 
			@ip.pick view,x,y
			if(@ip.valid?)
				if(@ip.edge && @ent1.include?(@ip.edge))
					@edge2 = @ip.edge; @e_len2=@edge2.length 
          
          #Data Input Section
          self.same_Joint
          if @use_ExistingData == "No"
            self.reset
            self.data_Input
            self.no_of_Offset_Input
            if @noOffsets >= 1 then self.input_Offsets
            end #@noOffsets
          else
            self.readExistingData
          end # if @use_ExistingData
          #DebugUI.messagebox("Edge = " + @edge)
          # Data Complete
          
					@mod.start_operation "Dovetail Pins"
					wid = @edge1.length; 
					#p2 = @ip.position; p2.transform! @tr2; edge=@ip.edge; pt,x2=edge.line
					#(pt = edge.end.position; x2.reverse!) if pt.distance(p2) > @ip.edge.length/2
					
					#Calculate Change in x due to @rise across thickness of Pin Board
					del_x = @rise * @p_length
					xcl = 1.0.to_l	#for testing dimension from outside edge to cl of next pin
					
					p0 = Geom.intersect_line_line(@edge1.line,@edge2.line)
					p1,x1=@edge1.line; cleanUP = "No"; cleanUP = "Yes" if p0 != p1; x1.reverse! if p0 != p1
					p1,ya=@edge2.line;  ya.reverse! if p0 != p1
          #Debug UI.messagebox("cleanUP = " + cleanUP.to_s)
					pa=p0.offset(ya,@e_len2)
          p0=p0.offset(ya,@e_len2 - @p_length)
					#Calculate offset points
					#no_of_Offset_Input
					#Get CL points for the pin features
					p0x = 0.0 #p0.x <--------------- changed this from p0.x to 0.0
					cal_xCL_points(p0x,wid)				
					i = 0
					for i in 0...@quanity-1	
						pp1=p0.offset(x1,@xcl[i]+@fpt/2) #pp1 (Pin Point 1) starts at half pin thickness from first @xcl
						pp2=pa.offset(x1,+@xcl[i]+@fpt/2+del_x)
						pp3=pa.offset(x1,@xcl[i+1]-@fpt/2-del_x)
						pp4=p0.offset(x1,@xcl[i+1]-@fpt/2)
							face= @ent1.add_face(pp1,pp2,pp3,pp4)
              loop = face.outer_loop
              edgeuses = loop.edgeuses
              edgeuse = edgeuses[3]
              edge = edgeuse.edge
							face.pushpull -@p_depth
              #After face is Pushed delete remaing edge
              if cleanUP == "Yes" && @apply_cleanUP == "Yes" then edge.erase! end
					end # for i
					@mod.commit_operation
					self.reset
          @comp2.hidden=false
					Sketchup.send_action "selectSelectionTool:"
				else
					UI.beep
				end # if(@ip.valid?)
			end
		end # if @status
	end#def onLButtonDown
	
	def onRButtonDown(flags,x,y,view)
		self.reset
		self.dialog
		self.no_of_Offset_Input
		if @noOffsets >= 1
			input_Offsets
		end
	end
		
	def onCancel(flag, view)
		view.refresh if @drawn
		Sketchup.send_action "selectSelectionTool:"
	end

	def draw(view)
		@drawn = false
		if( @ip.valid? && @ip.display? )
			@ip.draw(view)
			@drawn = true
		end
	end

end #of class K2_DovetailPins

class K2_DovetailTails	< K2_DovetailPins

	def initialize
		@mod = Sketchup.active_model
		@sel = @mod.selection
		@ip = Sketchup::InputPoint.new
		@inpt = Sketchup::InputPoint.new		
		@tinpt= Sketchup::InputPoint.new
		@labelText = "Tails to FIT these PIN Dimensions"
		@file =  __FILE__.gsub(/.rb$/,'.txt')
      if !(FileTest.exist?(@file)) 
        f = File.new(@file, "w+") 
        f.close
        reset
      else
        reset
        self.read_data
      end # FileTest
	end #initialize
  
  def same_Joint
      begin
        @edge1_Last = @ans[7].to_l;
      rescue
        @edge1_Last = 0; 
        #Debug UI.messagebox("blank data error rescued")
      end
     if @edge1_width == @edge1_Last 
        result = UI.messagebox('Repeat Last Joint?', MB_YESNO)
        if result == 6 
          @use_ExistingData = "Yes" # @use_ExistingData is not Saved (Secesion only data)
        else
          @use_ExistingData = "No"  # @use_ExistingData is not Saved (Secesion only data)
        end # if result
      else
        @use_ExistingData = "No"  # @use_ExistingData is not Saved (Secesion only data)
      end # if @e_len1
      
      #Debug UI.messagebox("use_ExistingData = " + @use_ExistingData.to_s)
    end # same_Joint
	
	def data_Input
		# open a file in read mode
		self.read_data
		prompts = ["Angle Units","Angle","End / Half Pin T @ Root","FullPin T @ Root","Pin Length","Pin Depth (Tail Bd T) ","Quanity","Spacing"]
		defaults= [@ans[0],@ans[1].to_s,@ans[2].to_s,@ans[3].to_s,@ans[9].to_s,@ans[4].to_s,@ans[6].to_s,@ans[5]]
		choices = ["Degree|Slope","","","","","","","Auto|Symmetrical|User|Fixed"]	 
		results = inputbox prompts, defaults, choices, @labelText
		if !results then;Sketchup.send_action "selectSelectionTool:";return;end
		
		@spc=results[0]; @ans[0] = results[0]
    @ang=results[1].to_f; @ans[1] = results[1]
      if @spc == "Degree" then	@rise = Math.tan(@ang.degrees) end
      if @spc == "Slope" then	@rise = @ang end
    @hpt=results[2].to_l; @ans[2] = results[2]
    @fpt=results[3].to_l; @ans[3] = results[3]
    @p_length = results[4].to_l; @ans[9] = results[4]
    @p_depth=results[5].to_l; @ans[4] = results[5]
    @quanity=results[6].to_i; @ans[6] = results[6]
		@spacing=results[7]; @ans[5] = results[7]
    
		# Write an array of Input Data to the file
		self.write_data
		
	end #data_Input

	def onMouseMove(flags, x, y, view)
		Sketchup::set_status_text("SELECT Dovetail TAIL Board Component:   SPACE BAR to Exit", SB_PROMPT) if @status==0 
    Sketchup::set_status_text("Select Pin Board Component Program will Hide :   [SPACE BAR] to Exit", SB_PROMPT) if @status==1
		Sketchup::set_status_text("Select Outside WIDTH EDGE on End of Tail Board Component:   SPACE BAR to Exit",SB_PROMPT) if @status==2
		Sketchup::set_status_text("Select TOP LENGTH EDGE on Outside of Tail Board Component:   SPACE BAR to Exit",SB_PROMPT) if @status==3
		@ip.pick view,x,y
		view.tooltip = @ip.tooltip	 
		view.refresh
	end
	
	def onLButtonDown(flags, x, y, view)
		if @status==0 #select 1st component
			ph=view.pick_helper; ph.do_pick x,y; @comp1=ph.best_picked
			if @comp1 && (@comp1.is_a?(Sketchup::ComponentInstance))
				@sel.add(@comp1); @ent1=@comp1.definition.entities; @status=1
				onMouseMove(flags, x, y, view)
			else
				UI.messagebox "Selection invalid, must be component"
			end #@comp1
      @status = 1
    elsif @status==1	#select 2nd component
			ph=view.pick_helper; ph.do_pick x,y; @comp2=ph.best_picked
			if @comp2 && (@comp2.is_a?(Sketchup::ComponentInstance))
				@sel.add(@comp2); @ent2=@comp2.definition.entities;  @status=2
				@tform2 = @comp2.transformation.inverse
				onMouseMove(flags, x, y, view)
				@sel.clear; @entity=@comp1; @sel.add(@comp1); @comp2.hidden=true
        @status = 2
			else
				UI.messagebox "Selection invalid, must be component"
			end #@entity	
		elsif @status==2 #select long edge, width
			@ip.pick view,x,y
			if(@ip.valid?)
				if(@ip.edge && @ent1.include?(@ip.edge))
					@edge1 = @ip.edge; @edge1_width=@edge1.length
					@status = 3
					onMouseMove(flags, x, y, view)
				else
					UI.messagebox"Other Component is Interfering with pick: Use Right Button Click and Hide before Continuing!"
					self.reset
				end
			end
		elsif @status==3 #select long edge, length 
			@ip.pick view,x,y
			if(@ip.valid?)
				if(@ip.edge && @ent1.include?(@ip.edge))
					@edge2 = @ip.edge; @edge2_length=@edge2.length          
          
          #Data Input Section
          self.same_Joint
          if @use_ExistingData == "No"
            self.data_Input
            self.no_of_Offset_Input
            if @noOffsets >= 1 then self.input_Offsets
            end #@noOffsets
          else
            begin
              self.readExistingData
            rescue
              UI.messagebox("Problem reading data! ReEnter Data")
              self.data_Input
            self.no_of_Offset_Input
              if @noOffsets >= 1 then self.input_Offsets
              end #@noOffsets
            end # begin
          end # if @use_ExistingDat
          
					@mod.start_operation "Dovtail Joint"
					wid = @edge1.length;
					#Tail Length Input Data
					read_data 
					#prompts = ["Tail Length"]
          #defaults= [@ans[7].to_s]
          #results = inputbox prompts, defaults, "Dovetail Tails Length"
					#if !results then;Sketchup.send_action "selectSelectionTool:";return;end
          #@p_length=results[0].to_l; @ans[7] = results[0]
					#write_data # Save Tail Length Data
					
					#Calculate Change in x due to @rise across thickness of Pin Board
					del_x = @rise * @p_length
					xcl = 1.0.to_l	#for testing dimension from outside edge to cl of next pin
					#Calculate Starting Points
					p0 = Geom.intersect_line_line(@edge1.line,@edge2.line)
					p1,x1=@edge1.line; cleanUP = "No"; cleanUP = "Yes" if p0 != p1; x1.reverse! if p0 != p1
          #Debug  UI.messagebox("cleanUP = " + cleanUP.to_s)
					p1,ya=@edge2.line; ya.reverse! if p0 != p1
					#UI.messagebox("ya = "+ ya.to_s)
					#UI.messagebox("hgt = "+ hgt.to_s)
					pa=p0.offset(ya,@p_length)
					
					#Get CL points for the pin features
					p0x = 0.0 #p0.x <--------------- changed this from p0.x to 0.0
					cal_xCL_points(p0x,wid)					

					pp1=pa; pp2=p0
					for i in 0...@quanity-1
						pp3=p0.offset(x1,@xcl[i]+@fpt/2)
						pp4=pa.offset(x1,@xcl[i]+@fpt/2+del_x)
						face= @ent1.add_face(pp1,pp2,pp3,pp4)
            face.pushpull -@p_depth
						pp1=pa.offset(x1,@xcl[i+1]-@fpt/2-del_x)
						pp2=p0.offset(x1,@xcl[i+1]-@fpt/2) #pp1 (Pin Point 1) starts at half pin thickness from first @xcl
					end
					pp3=p0.offset(x1,wid); pp4=pa.offset(x1,wid)
					face= @ent1.add_face(pp1,pp2,pp3,pp4)             
          face.pushpull -@p_depth              
					@mod.commit_operation
          @comp2.hidden=false
					self.reset
					Sketchup.send_action "selectSelectionTool:"
				else
					UI.beep
				end
			end
		end
	end#def onLButtonDown

end #class K2_DovetailTails

end #module
#-----------------------------------------------------------------------------
file_loaded("KK_DovetailTool_2.rb") 
