#
#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
  #portions of this code are modifications of examples from Google
  # Copyright 2005-2007, Google, Inc.
  # 
  # Name :        K2_ToolsBiscuitJoint  ###
  # Date :	      July 2014
  # Version :     2.1.0
  # Author :      Keith Krueger (with a big help from plugin forum)
  #
  #This Program Loads the Individual K2_Tools when their Menu is accessed!
  
  
require 'K2WS_Tools/k2ws_module.rb' #-NameSpace Module

# Test to see if Old Version with different file name exist and delete if present!
if (FileTest.exist?(File.join(File.dirname(File.dirname(__FILE__)), 'loadK2WS_Tools.rb')))
  require(File.join(File.dirname(__FILE__), 'delete_loadK2WS_Tools.rb'))
  UI.messagebox("IMPORTANT:  AN UPDATE was required & Old Files Deleted \n Restart SketchUp to Complete Installation\n  K2WS_Tools Plugin Ver 2.0.0 ")
end
if (FileTest.exist?(File.join(File.dirname(File.dirname(__FILE__)), 'loadK2WS_Tools.rb!')))
  require(File.join(File.dirname(__FILE__), 'delete_loadK2WS_Tools.rb'))
  UI.messagebox("IMPORTANT:  AN UPDATE was required & Old Files Deleted \n Restart SketchUp to Complete Installation\n  K2WS_Tools Plugin Ver 2.0.0 ")
end

module K²WS::K2_ToolsLoader

  class << self

    #ToolBars are only created when Menu Item is selected
    
    def biscuit_ToolBar	
      if  @tlb1== nil
        itcmd11 = UI::Command.new("Biscuit Joint") {biscuitJointTool}
        itcmd11.tooltip = "Biscuit Joint"
        itcmd11.status_bar_text = "Add Biscuit Slots to Both Components or One Component and Opt to Add Biscuits"
        itcmd11.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Jt_small.png")
        itcmd11.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","JT_large.png")
        itcmd13 = UI::Command.new("Biscuit Help") {biscuitHelp}
        itcmd13.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_Small.png")
        itcmd13.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_large.png")
        itcmd13.tooltip = "Biscuit Help"
        itcmd13.status_bar_text = "Displays Images and Text to Illustrate Using Biscuit Tool"
        @tlb1 = UI::Toolbar.new("Biscuit Joint")
        @tlb1.add_item(itcmd11)
        @tlb1.add_item(itcmd13)
        @tlb1.show
      else
        #state = @tlb1.get_last_state
        #UI.messagebox("State of Biscuit ToolBar " + state.to_s)
        @tlb1.show
      end
    end
    
    def biscuitJointTool
      require  'K2WS_Tools/K2_ToolsBiscuitJoint.rb'
      Sketchup.active_model.select_tool K²WS::K2_ToolsBiscuitJoint.new  
    end
   
    def biscuitHelp
      biscuit_help_File = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","K2_Tools_BiscuitHelp.html")
      UI.openURL("file:///#{biscuit_help_File}")
    end #def biscuitHelp
    
    def boxJoint_ToolBar	
      if  @tlb2== nil
        itcmd21 = UI::Command.new("Box Joint") {boxJointFingers}
        itcmd21.tooltip = "Box Joint"
        itcmd21.status_bar_text = "Add Box Joint Fingers to One Component of a Box Joint"
        itcmd21.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","BoxJoint_small.png")
        itcmd21.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","BoxJoint_large.png")
        itcmd22 = UI::Command.new("BoxJoint Help") {boxJointHelp}
        itcmd22.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_Small.png")
        itcmd22.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_large.png")
        itcmd22.tooltip = "Box Joint Help"
        itcmd22.status_bar_text = "Displays Images and Text to Illustrate Using Box Joint Tool"
        @tlb2 = UI::Toolbar.new("Box Joint")
        @tlb2.add_item(itcmd21)
        @tlb2.add_item(itcmd22)
        @tlb2.show
      else
        #state = @tlb2.get_last_state
        #UI.messagebox("State of BoxJoint ToolBar " + state.to_s)
        @tlb2.show
      end
    end
    
    def boxJointFingers  
      require  'K2WS_Tools/K2_ToolsBoxJoint.rb'
      Sketchup.active_model.select_tool K²WS::K2_BoxFingers.new   
    end
    
    def boxJointHelp
      boxJoint_help_File = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","K2_Tools_BoxJointHelp.html")
      UI.openURL("file:///#{boxJoint_help_File}")
    end #def boxJointHelp
    
    def domino_ToolBar	
      if  @tlb3== nil
        itcmd31 = UI::Command.new("Domino Joint") {dominoJoint}
        itcmd31.tooltip = "Domino Joint"
        itcmd31.status_bar_text = "Add Domino Slots to Both Components or One Component with Opt to Add Dominos"
        itcmd31.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Jt_small.png")
        itcmd31.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","JT_large.png")
        itcmd33 = UI::Command.new("Domino Help") {dominoHelp}
        itcmd33.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_Small.png")
        itcmd33.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_large.png")
        itcmd33.tooltip = "Domino Help"
        itcmd33.status_bar_text = "Displays Images and Text to Illustrate Using Domino Tool"
        @tlb3 = UI::Toolbar.new("Dominos")
        @tlb3.add_item(itcmd31)
        @tlb3.add_item(itcmd33)
        @tlb3.show
      else
        #state = @tlb3.get_last_state
        #UI.messagebox("State of Domino ToolBar " + state.to_s)
        @tlb3.show
      end
    end
    
    def dominoJoint  
      require  'K2WS_Tools/K2_ToolsDominoJoint.rb'
      Sketchup.active_model.select_tool K²WS::K2_Tools_DominoJoint.new   
    end
   
    def dominoHelp
      domino_help_File = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","k2ws_DominoHelp.html")
      UI.openURL("file:///#{domino_help_File}")
    end #def dominoHelp
    
    def dovetail_ToolBar	
      if  @tlb4== nil
        itcmd41 = UI::Command.new("Pins for Dovetail Joint") {dovetailPintool}
        itcmd41.tooltip = "Dovetail Pins"
        itcmd41.status_bar_text = "Add Dovetail Pins to Single Component"
        itcmd41.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Dovetail_Pins_Small.png")
        itcmd41.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Dovetail_Pins_large.png")
        itcmd42 = UI::Command.new("Tails for Dovetail Joint") {dovetailTailtool}
        itcmd42.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Dovetail_Tails_Small.png")
        itcmd42.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Dovetail_Tails_large.png")
        itcmd42.tooltip = "Dovetail Tails"
        itcmd42.status_bar_text = "Add Dovetail Tails to Single Component"
        itcmd43 = UI::Command.new("Dovetail Help") {dovetailHelp}
        itcmd43.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_Small.png")
        itcmd43.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_large.png")
        itcmd43.tooltip = "Dovetail Help"
        itcmd43.status_bar_text = "Displays Images and Text to Illustrate Using Dovetail Tool"
        @tlb4 = UI::Toolbar.new("Dovetail")
        @tlb4.add_item(itcmd41)
        @tlb4.add_item(itcmd42)
        @tlb4.add_item(itcmd43)
        @tlb4.show
      else
        #state = @tlb4.get_last_state
        #UI.messagebox("State of Dovetail ToolBar " + state.to_s)
        @tlb4.show
      end
    end
     
    def dovetailPintool
      require  'K2WS_Tools/K2_ToolsDovetail.rb'
      Sketchup.active_model.select_tool K²WS::K2_DovetailPins.new
    end #def dovetailPintool
    
    def dovetailTailtool
      require  'K2WS_Tools/K2_ToolsDovetail.rb'
      Sketchup.active_model.select_tool K²WS::K2_DovetailTails.new
    end
    
    def dovetailHelp
      dovetail_help_File = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","K2_Tools_DovetailHelp.html")
      UI.openURL("file:///#{dovetail_help_File}")
    end #def dovetailHelp
    
    def dowel_ToolBar	
      if  @tlb5== nil
        itcmd51 = UI::Command.new("Dowel Joint") {dowelJoint}
        itcmd51.tooltip = "Dowel Joint"
        itcmd51.status_bar_text = "Add Dowel Holes to Both Components or One Component with Opt to Add Dowels"
        itcmd51.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Jt_small.png")
        itcmd51.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","JT_large.png")
        itcmd53 = UI::Command.new("Dowels Help") {dowelHelp}
        itcmd53.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_Small.png")
        itcmd53.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_large.png")
        itcmd53.tooltip = "Dowel Help"
        itcmd53.status_bar_text = "Displays Images and Text to Illustrate Using Dowel Tool"
        @tlb5 = UI::Toolbar.new("Dowels")
        @tlb5.add_item(itcmd51)
        @tlb5.add_item(itcmd53)
        @tlb5.show
      else
        #state = @tlb5.get_last_state
        #UI.messagebox("State of Dowel ToolBar " + state.to_s)
        @tlb5.show
      end
    end

    def dowelJoint  
      require  'K2WS_Tools/K2_ToolsDowelJoint.rb'
      Sketchup.active_model.select_tool K²WS::K2_Tools_Dowel_Joint.new   
    end
    
    def dowelHelp
      dowel_help_File = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","k2ws_DowelHelp.html")
      UI.openURL("file:///#{dowel_help_File}")
      #Debug UI.messagebox("Dowel Help Complete " + dowel_help_File.to_s)
    end #def dowelHelp
    
    def looseTenon_ToolBar	
      if  @tlb6== nil
        itcmd61 = UI::Command.new("Loose Tenon Joint") {looseTenonJointtool}
        itcmd61.tooltip = "Loose Tenon Joint"
        itcmd61.status_bar_text = "Add Loose Tenon Slots to Both Components or One Component with Opt to Add Loose Tenons"
        itcmd61.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Jt_small.png")
        itcmd61.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","JT_large.png")
        itcmd63 = UI::Command.new("LT Help") {lt_Help}
        itcmd63.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_Small.png")
        itcmd63.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_large.png")
        itcmd63.tooltip = "LT Help"
        itcmd63.status_bar_text = "Displays Images and Text to Illustrate Using Loose Tenon Tool"
        @tlb6 = UI::Toolbar.new("Loose Tenon")
        @tlb6.add_item(itcmd61)
        @tlb6.add_item(itcmd63)
        @tlb6.show
      else
        #state = @tlb6.get_last_state
        #UI.messagebox("State of Loose Tenon" + state.to_s)
        @tlb6.show
      end
    end
    
    def looseTenonJointtool
      require  'K2WS_Tools/K2_ToolsLooseTenon.rb'
      Sketchup.active_model.select_tool K²WS::K2_LooseTennonJointTool.new
    end
    
    def lt_Help
      lt_help_File = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","k2ws_LT_Help.html")
      UI.openURL("file:///#{lt_help_File}")
    end #def lt_Help

    
    def mortise_Tenon_ToolBar	
      if  @tlb7== nil
        itcmd71 = UI::Command.new("Mortise & Tenon Joint") {mortise_TenonJoint}
        itcmd71.tooltip = "Mortise & Tenon Joint"
        itcmd71.status_bar_text = "Select Add Tenon to Component 1 and/or Mortise to Component 2"
        itcmd71.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Jt_small.png")
        itcmd71.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","JT_large.png")
        itcmd73 = UI::Command.new("M&T Help") {mt_Help}
        itcmd73.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_Small.png")
        itcmd73.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_large.png")
        itcmd73.tooltip = "M&T Help"
        itcmd73.status_bar_text = "Displays Images and Text to Illustrate Using Mortise and Tenon Tool"
        @tlb7 = UI::Toolbar.new("Mortise/Tenon")
        @tlb7.add_item(itcmd71)
        @tlb7.add_item(itcmd73)
        @tlb7.show
      else
        #state = @tlb7.get_last_state
        #UI.messagebox("State of Loose Tenon " + state.to_s)
        @tlb7.show
      end
    end
    
    def mortise_TenonJoint
      require  'K2WS_Tools/K2_ToolsM_TJoint.rb'
      Sketchup.active_model.select_tool K²WS::K2_M_T_Joint.new  
    end
    
    def mt_Help
      mt_help_File = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","k2ws_MT_Help.html")
      UI.openURL("file:///#{mt_help_File}")
    end #def mt_Help
    
    def pocketscw_ToolBar	
      if  @tlb8== nil
        itcmd81 = UI::Command.new("Pocket Screw Holes") {pocketscw_holes}
        itcmd81.tooltip = "Pocket Screw Holes"
        itcmd81.status_bar_text = "Add Pocket Screw Holes to Face of a Single Component"
        itcmd81.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","PocketScrew_small.png")
        itcmd81.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","PocketScrew_large.png")
        itcmd82 = UI::Command.new("Pocket Screw Help") {pocketscwHelp}
        itcmd82.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_Small.png")
        itcmd82.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_large.png")
        itcmd82.tooltip = "Pocket Screw Help"
        itcmd82.status_bar_text = "Displays Images and Text to Illustrate Pocket Screw Holes"
        @tlb8 = UI::Toolbar.new("Pocket Screws")
        @tlb8.add_item(itcmd81)
        @tlb8.add_item(itcmd82)
        @tlb8.show
      else
        #state = @tlb8.get_last_state
        #UI.messagebox("State of Pocket Screw ToolBar " + state.to_s)
        @tlb8.show
      end
    end
    
    def pocketscw_holes
      require  'K2WS_Tools/K2_ToolsPocketScwHoles.rb'
      Sketchup.active_model.select_tool K²WS::K2_Tools_PocketScwHoles.new
    end
    
    def pocketscwHelp
      pocketscw_help_File = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","K2_Tools_PocketSH_Help.html")
      UI.openURL("file:///#{pocketscw_help_File}")
    end #def pocketscwHelp
    
    def screwHole_ToolBar	
      if  @tlb9== nil
        itcmd91 = UI::Command.new("Screw Holes") {screw_holes}
        itcmd91.tooltip = "Screw Holes"
        itcmd91.status_bar_text = "Add Screw Holes to Face of a Single Component"
        itcmd91.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","ScrewHole_small.png")
        itcmd91.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","ScrewHole_large.png")
        itcmd92 = UI::Command.new("Screw Hole Help") {screw_holesHelp}
        itcmd92.small_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_Small.png")
        itcmd92.large_icon = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","Icons","Help_large.png")
        itcmd92.tooltip = "Screw Hole Help"
        itcmd92.status_bar_text = "Displays Images and Text to Illustrate Adding Screw Holes"
        @tlb9 = UI::Toolbar.new("ScwHoles")
        @tlb9.add_item(itcmd91)
        @tlb9.add_item(itcmd92)
        @tlb9.show
      else
        #state = @tlb8.get_last_state
        #UI.messagebox("State of Screw Holes ToolBar " + state.to_s)
        @tlb9.show
      end
    end
    
    def screw_holes
      require  'K2WS_Tools/K2_ToolsScrewHoles.rb'
      Sketchup.active_model.select_tool  K²WS::K2_Tools_ScrewHoles.new
    end
    
    def screw_holesHelp
      screw_holes_help_File = File.join(File.dirname(__FILE__),"K2_ToolsSupportFiles","K2_Tools_ScrewHoleHelp.html")
      UI.openURL("file:///#{screw_holes_help_File}")
    end #def screw_holesHelp
    
   
	
  end # proxy class
  
  #Run Once
	unless file_loaded?(File.basename(__FILE__))
		
    # Access the main Tools menu
    tools_menu = UI.menu "Tools"
    # Add a separator and a submenu
    tools_menu.add_separator
    sub_menu = tools_menu.add_submenu("KK_Tools")
    # Add items to the submenu
		it1= sub_menu.add_item("Biscuits"){biscuit_ToolBar}
		it2= sub_menu.add_item("BoxJoint"){boxJoint_ToolBar}	
    it3= sub_menu.add_item("Dominos"){domino_ToolBar}
    it4= sub_menu.add_item("Dovetails"){dovetail_ToolBar}
    it5= sub_menu.add_item("Dowels"){dowel_ToolBar}
    it6= sub_menu.add_item("Loose-Tenon Joint"){looseTenon_ToolBar}
    it7= sub_menu.add_item("Mortise & Tenon Joint"){mortise_Tenon_ToolBar}
    it8= sub_menu.add_item("Pocket Scw Holes"){pocketscw_ToolBar}
    it9= sub_menu.add_item("Screw Holes"){screwHole_ToolBar}
    
  file_loaded(File.basename(__FILE__))  
     
  end #End Run Once 

 
 end #module K²WS::K2_ToolsLoader
 
 