


#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
  #portions of this code are modifications of examples from Google
  # Copyright 2005-2007, Google, Inc.
  # 
  # Name :        K2_ToolsLooseTenon.rb  ###
  # Date :	      July 2014
  # Version :     2.1.0
  # Author :      Keith Krueger (with a big help from plugin forum)
  #
 
require 'sketchup.rb'
require 'K2WS_Tools/k2ws_module.rb' #-NameSpace Module

module K²WS
 
class K2_LooseTennonJointTool 
    
	def initialize
      @mod = Sketchup.active_model
      @sel = @mod.selection
      @opt_LEN_No = Sketchup.active_model.options["UnitsOptions"]["LengthUnit"]
      @opt_Format_No = Sketchup.active_model.options["UnitsOptions"]["LengthFormat"]
      @opt_Precision_No = Sketchup.active_model.options["UnitsOptions"]["LengthPrecision"]
      @ans=Array.new
      #Test for Acceptable Units/Format and Set rnd_Factor
      @rnd_Factor = 0
      if @opt_LEN_No == 0 && @opt_Format_No == 0 then @rnd_Factor = 10.0**-(1*@opt_Precision_No) end
      if @opt_LEN_No == 0 && @opt_Format_No == 3 then @rnd_Factor = 0.015625 * 2**(6 - @opt_Precision_No) end
      if @opt_LEN_No == 2 && @opt_Format_No == 0 then @rnd_Factor = 0.0393701 * 10**-(1*@opt_Precision_No) end
      if @rnd_Factor == 0
        UI.messagebox("Units must be Inches or Millimeters \n Fromat must be Decimal or Fractions \n \n CHANGE UNITS & RE-SELECT TOOL ")
        Sketchup.send_action "selectSelectionTool:"
      else
        #Debug        UI.messagebox("@rnd_Factor = " + @rnd_Factor.to_s)
      end #if @rnd_Factor      
      @ip = Sketchup::InputPoint.new
      @file =  __FILE__.gsub(/.rb$/,'.txt')
      if !(FileTest.exist?(@file)) 
        f = File.new(@file, "w+") 
        f.close
        self.reset
      else
        self.reset
        self.read_data
      end # FileTest
    end  #def initialize
	
	def read_data
      # Read an array of Input Data from the file 
      # open input data file in read mode	       
      f = File.open(@file, "r")    
      @ans = f.readlines
      #strip end of line or file from all data
      @ans = @ans.collect { |data|
        data.strip 
      }
      # Close the file
      f.close		
    end #read_data
	
	def write_data
		# Write an array of Input Data to the file
		# open input data file in write mode	       
		f = File.open(@file, "w")
		f.puts @ans
		# Close the file
		f.close
	end
	
	def readExistingData
		self.read_data
		
		@thickness = @ans[0].to_l 		
		@spacing_Type = @ans[1]
		@width = @ans[2].to_l                 
		@quanity = @ans[3].to_i                 
		@edge2CL = @ans[4].to_l                 
		@end2CL = @ans[5].to_l 		
		@mdC1 = @ans[6].to_l      
		@mdC2 = @ans[7].to_l
    @d_Comp1 = @ans[8].to_l
    @lt_length = @ans[9].to_l
    @lt_name = @ans[10]
    @d_Comp2 = @ans[11].to_l
    @thru_Mortise = @ans[12]
    @edge1_Last = @ans[13].to_l
    @edge2_Last = @ans[14].to_l
    #Open = @ans[15]
    
    @xf = (@width - @thickness)/2.0 #Flat length
    
		 self.no_of_Offset_Input
      n = @noOffsets
      @cl_offset=Array.new n
      i = 1
      i2 = 2
      while n > 0
        @cl_offset[i-1]=(@ans[16+i].to_s.strip.to_l)     
        n = n-1
        i = i+1
        i2 = i2+1		
      end #while n > 0
	end #readExistingData
	
	def reset
		@best = nil; @comp1 = nil; @comp2 = nil; @sel.clear; @status = 0; @drawn = false
    @addLooseTenons = "No";  @add_LTSlots_Comp2 = "No"; @add_LTSlots_Comp1 = "No"
	end
  
  def same_Joint
      begin
        @edge1_Last = @ans[13].to_l; @edge2_Last = @ans[14].to_l
      rescue
        @edge1_Last = 0; @edge2_Last = 0
        #Debug UI.messagebox("blank data error rescued")
      end
      if @e_len1 == @edge1_Last && @e_len2 == @edge2_Last
        result = UI.messagebox('Use Existing Loose Tenon Joint Data ???', MB_YESNO)
        if result == 6 
          @use_ExistingData = "Yes" # @use_ExistingData is not Saved (Secesion only data)
        else
          @use_ExistingData = "No"  # @use_ExistingData is not Saved (Secesion only data)
        end # if result
      else
        @use_ExistingData = "No"  # @use_ExistingData is not Saved (Secesion only data)
      end # if @e_len1
      # Save current edge1 & edge2 Length
      @ans[13] = @e_len1.to_s;  @ans[14] = @e_len2.to_s
      write_data
    end # same_Joint
  
  def select_LooseTenon
    prompts = ["Joint Face READ ONLY  ","LT Thickness","LT Width", "LT Length","Quanity"]
    defaults = [@e_len2.to_s + " x " + @e_len1.to_s,@ans[0],@ans[2].to_s,@ans[9].to_s,@ans[3].to_s]
    choices = ["","","","",""]
    results = inputbox prompts, defaults, choices, "Input Loose Tenon Specifications"
    if results == false then self.reset end; Sketchup.send_action "selectSelectionTool:"
    @thickness = results[1].to_l; @ans[0] = results[1]
    @width = results[2].to_l ; @ans[2] = results[2]
    @lt_length = results[3].to_l ; @ans[9] = results[3]
      @xf = (@width - @thickness)/2.0 #Flat length
    @quanity = results[4].to_i; @ans[3] = results[4]
  
    write_data    
  
  end # select_LooseTenon
  
	def data_Input_Form
  
		# open input data file in read mode	       
		self.read_data
    cl_edge1 = @e_len1/2; cl_edge2 = round_to(@e_len2/2.0); end_toCL_first = round_to(((@width/2.0)+@thickness)) 
    if @quanity == 1
      prompts = ["Joint Face READ ONLY  ","Edge 1 to CL LTenon","End to CL LTenon","LTenon Depth Comp1","Through Mortise? "]
      defaults= [@e_len2.to_s + " x " + @e_len1.to_s,cl_edge2.to_s,cl_edge1.to_s,@ans[8].to_s,@ans[12].to_s]
      choices = ["","","","","No|Comp 1|Comp 2|Both Comp"]
    else
      prompts = ["Joint Face READ ONLY  ","Edge 1 to CL LTenons","End to CL First LTenon","LTenon Depth Comp1","Through Mortise? ","Space Between LTenons"]
      defaults= [@e_len2.to_s + " x " + @e_len1.to_s,cl_edge2.to_s,end_toCL_first.to_s,@ans[8].to_s,@ans[12].to_s,@ans[1]]
      choices = ["","","","","No|Comp 1|Comp 2|Both Comp","Auto|User"]
    end # if @quanity
		results = inputbox prompts, defaults, choices, "Data for Loose Tenon Joint (LT: " + @thickness.to_s + " x " + @width.to_s + " x " + @lt_length.to_s + ")"
		if results == false then self.reset end; Sketchup.send_action "selectSelectionTool:"
    @edge2CL = results[1].to_l; @ans[4] = results[1]
    @end2CL = results[2].to_l; @ans[5] = results[2]
    @d_Comp1 = results[3].to_l; @ans[8] = results[3]; @d_Comp2 = (@lt_length - @d_Comp1); @ans[11] = @d_Comp2.to_s
    @thru_Mortise = results[4]; @ans[12] = results[4]
    if @quanity == 1
      @spacing_Type = "Auto"
      #Debug UI.messagebox("spacing_Type set to  " + @spacing)
    else
      @spacing_Type = results[5]; @ans[1] = results[5]                          
    end #if @quanity
    if @thru_Mortise == "No"
      @mdC1 = @d_Comp1; @ans[6] = @mdC1.to_s
      @mdC2 = @lt_length - @d_Comp1; @ans[7] = @mdC2.to_s
    else
      mortise_Thru_Depth
    end # if @thru_Mortise  
		# Write an array of Input Data to the file
		self.write_data
    
	end #data_Input_Form
   

	def mortise_Thru_Depth

		if @thru_Mortise == "Comp 1"
      prompts = ["Depth Thru Mortise Comp 1 "]
      defaults= [@ans[6].to_s]
      choices = [""]
      results = inputbox prompts, defaults, choices, "Through Mortise Depth COMPONENT 1"
      if results == false then self.reset end; Sketchup.send_action "selectSelectionTool:"
      @mdC1 = results[0].to_l; @ans[6] = results[0]
      @mdC2 = @d_length - @d_Comp1; @ans[7] = @mdC2.to_s
    elsif @thru_Mortise == "Comp 2"
      prompts = ["Depth Thru Mortise Comp 2 "]
      defaults= [@ans[7].to_s]
      choices = [""]
      results = inputbox prompts, defaults, choices, "Through Mortise Depth COMPONENT 2"
      if results == false then self.reset end; Sketchup.send_action "selectSelectionTool:"
      @mdC1 = @d_Comp1; @ans[6] = @mdC1.to_s
      @mdC2 = results[0].to_l; @ans[7] = results[0]
    elsif @thru_Mortise == "Both Comp"
      prompts = ["Depth Thru Mortise Comp 1 ","Depth Thru Mortise Comp 2 "]
      defaults= [@ans[6].to_s,@ans[7].to_s]
      choices = ["",""]
      results = inputbox prompts, defaults, choices, "Through Mortise Depth Both COMPONENTS"
      if results == false then self.reset end; Sketchup.send_action "selectSelectionTool:"
      @mdC1 = results[0].to_l; @ans[6] = results[0]
      @mdC2 = results[1].to_l; @ans[7] = results[1]
    end #@thru_Mortise
		# open input data file in write mode	       
		self.write_data
    
	end #mortise_Thru_Depth
  
	def select_Tool_Options
    @add_LTSlots_Comp1 = "No"
    @add_LTSlots_Comp2 = "No"
    @addLooseTenons = "No"
    prompts = ["Select Tool Option"]
    defaults= ["Complete Joint"]
    choices = ["Complete Joint|Comp 1 Slots + L_Tenons|Add L_Tenons|Comp1 Slots|Comp 2 Slots|Comp 1 & 2 Slots|comp 2 Slots + L_Tenons_"]
    results = inputbox prompts, defaults, choices, "Select Loose_Tenon Joint Tool Options"
    if results == false then self.reset end; Sketchup.send_action "selectSelectionTool:"
    case results[0]
      when "Complete Joint"
        @add_LTSlots_Comp1 = "Yes"
        @add_LTSlots_Comp2 = "Yes"
        @addLooseTenons = "Yes"
      when "Comp 1 Slots + L_Tenons"
        @add_LTSlots_Comp1 = "Yes"
        @addLooseTenons = "Yes"
      when "Add L_Tenons"
        @addLooseTenons = "Yes"
      when "Comp1 Slots"
        @add_LTSlots_Comp1 = "Yes"
      when "Comp 2 Slots"
        @add_LTSlots_Comp2 = "Yes"
      when "Comp 1 & 2 Slots"
        @add_LTSlots_Comp1 = "Yes"
        @add_LTSlots_Comp2 = "Yes"
      when "comp 2 Slots + L_Tenons_"
        @add_LTSlots_Comp2 = "Yes"
        @addLooseTenons = "Yes"
    end # case results
  end # select_Tool_Options
    
  def lt_name
      #loose tenon name based on thickness, width and length
      @lt_name = ("Part LT: " + @thickness.to_s + " x " + @width.to_s + " x " + @lt_length.to_s)
      #Debug  UI.messagebox("Loose Tenon Name = " + @lt_name.to_s)
  end #lt_name
  
	def no_of_Offset_Input
      case @spacing_Type    
        when "Auto"
          @noOffsets = 0
        when "User"
          @noOffsets = @quanity - 1
      end #case @spacing_Type
      self.write_data
      #Debug UI.messagebox("No of Offsets =" + @noOffsets.to_s)
    end #no_of_offsets
    
  def round_to(num)
      #Debug      UI.messagebox("origional no =  " + num.to_s)
      num_R = ((num + (@rnd_Factor/2.0))/@rnd_Factor).to_i*@rnd_Factor
      num_R = num_R.to_l
      #Debug      UI.messagebox("rounded no =  " + num_R.to_s)
      return num_R
  end #round_to  
    
	def round_3places(n)  
		n=(n*1000).to_i
		n=n.to_f/1000      
	end #def round_3places
  
	def input_Offsets
		# open a file in read mode	       
		f = File.open(@file, "r")  
		ans = f.readlines
		# Close the file
		f.close
		n = @noOffsets
		@cl_offset=Array.new n
		i = 1
		i2 = 2
    space = round_to(@e_len1 - @end2CL)
    while n > 0
      prompts = ["CL Distance LTenon " + i.to_s + " to LTenon " + i2.to_s + " ","Remaining Space   READ ONLY  ","Number Spaces   READ ONLY  "]
      defaults= [@ans[16+i].to_s,space.to_s,n.to_s]
      results = inputbox prompts, defaults, "Input CL Distance between Biscuits"
      @cl_offset[i-1]=results[0].to_l; @ans[16+i] = results[0]
      space = round_to(space - @cl_offset[i-1])
      n = n-1
      i = i+1
      i2 = i2+1		
    end #while n > 0
    self.write_data         
	end #def input_Offsets 

	def cal_xCL_points(x1,e_len,dir_x)
		@xcl=Array.new @quanity.to_i
		case @spacing_Type         
			when "Auto"
				#Debug UI.messagebox("Case Spacing = " + @spacing_Type.to_s)
        if @quanity == 1
          @xcl[0]=x1+(@end2CL*dir_x)
        else
				equal_offset=(e_len-(@end2CL*2))/(@quanity-1)
				@xcl[0]=x1+(@end2CL*dir_x)
				@xcl[@quanity-1]=x1+((e_len-@end2CL)*dir_x)
				n =(@quanity-2)  #loop number
				sn = 1 #Starting number
				while n > 0
					@xcl[sn]=@xcl[sn-1]+((equal_offset)*dir_x)
					sn = sn + 1
					n = n -1
				end # while n > 0
        end # if @quanity
			#Debug @xcl.each {|e| UI.messagebox("Equal CL point = "+ e.to_s)}        
			when "User"
				#Debug UI.messagebox("Case Spacing = " + @spacing_Type.to_s)
				@xcl[0]=x1+(@end2CL*dir_x)
				n =(@quanity-1)  #loop number
				sn = 1 #Starting number
				i = 0
				while n > 0
					user_offset=@cl_offset[i]
					#user_offset=user_offset.to_l
					#Debug UI.messagebox("user_offset = "+ user_offset.to_s)
					@xcl[sn]=@xcl[sn-1]+((user_offset)*dir_x)
					sn = sn + 1
					i = i + 1
					n = n -1
				end # while n > 0
			#Debug @xcl.each {|e| UI.messagebox("User CL point = "+ e.to_s)} 
		end #case @spacing_Type
		#Debug UI.messagebox("End Spacing = " + @spacing_Type.to_s)
	end #cal_xCL_points

	def points_MortiseRd(x,y,z,r)
		@pt=Array.new 14
    #Debug UI.messagebox("@xf  = " + @xf.to_s)
		@pt[0]=Geom::Point3d.new((x+@xf)+r,y,z)
		@pt[1]=Geom::Point3d.new((x+@xf)+(0.866*r),y+(0.5*r),z)
		@pt[2]=Geom::Point3d.new((x+@xf)+(0.5*r),y+(0.866*r),z)
		@pt[3]=Geom::Point3d.new((x+@xf),y+r,z)
		@pt[4]=Geom::Point3d.new((x-@xf),y+r,z)
		@pt[5]=Geom::Point3d.new((x-@xf)-(0.5*r),y+(0.866*r),z)
		@pt[6]=Geom::Point3d.new((x-@xf)-(0.866*r),y+(0.5*r),z)
		@pt[7]=Geom::Point3d.new((x-@xf)-r,y,z)
		@pt[8]=Geom::Point3d.new((x-@xf)-(0.866*r),y-(0.5*r),z)
		@pt[9]=Geom::Point3d.new((x-@xf)-(0.5*r),y-(0.866*r),z)
		@pt[10]=Geom::Point3d.new((x-@xf),y-r,z)
		@pt[11]=Geom::Point3d.new((x+@xf),y-r,z)
		@pt[12]=Geom::Point3d.new((x+@xf)+(0.5*r),y-(0.866*r),z)
		@pt[13]=Geom::Point3d.new((x+@xf)+(0.866*r),y-(0.5*r),z)   
		#Debug  @pt.each {|e| UI.messagebox("point = "+ e.to_s)}    
	end #points_MortiseRd
  

  def find_LTComp(model,entities,definitions)
     
      length = definitions.length
      dname = ""
      i=0
      loop do
        i += 1
        break if i==length
        definition = definitions[length-i]
        dname = definition.name
        #Debug UI.messagebox("definition.name = " + dname.to_s)
        break if dname == @lt_name
      end  
        if dname == @lt_name
        @lt_exist = "yes"
        @lt_definition = definitions[length-i]
      end #if dname
    end #find_LTComp
  
  def points_LT_CL(x,y) 
    @clpt=Array.new 4
    @clpt[0]=Geom::Point3d.new(x,y,0)
    @clpt[1]=Geom::Point3d.new(x+1,y,0)
    @clpt[2]=Geom::Point3d.new(x,y+0.5,0)
    @clpt[3]=Geom::Point3d.new(x,y,2)
    #Debug @clpt.each {|e| UI.messagebox("CL point L_Tenon = "+ e.to_s)}
    end #def points_LT_CL
  
  def points_LTenon(x,y,z,r,dxf)
		@ptd=Array.new 14
    #Debug UI.messagebox("@xf  = " + @xf.to_s)
		@ptd[0]=Geom::Point3d.new((x+dxf)+r,y,z)
		@ptd[1]=Geom::Point3d.new((x+dxf)+(0.866*r),y+(0.5*r),z)
		@ptd[2]=Geom::Point3d.new((x+dxf)+(0.5*r),y+(0.866*r),z)
		@ptd[3]=Geom::Point3d.new((x+dxf),y+r,z)
		@ptd[4]=Geom::Point3d.new((x-dxf),y+r,z)
		@ptd[5]=Geom::Point3d.new((x-dxf)-(0.5*r),y+(0.866*r),z)
		@ptd[6]=Geom::Point3d.new((x-dxf)-(0.866*r),y+(0.5*r),z)
		@ptd[7]=Geom::Point3d.new((x-dxf)-r,y,z)
		@ptd[8]=Geom::Point3d.new((x-dxf)-(0.866*r),y-(0.5*r),z)
		@ptd[9]=Geom::Point3d.new((x-dxf)-(0.5*r),y-(0.866*r),z)
		@ptd[10]=Geom::Point3d.new((x-dxf),y-r,z)
		@ptd[11]=Geom::Point3d.new((x+dxf),y-r,z)
		@ptd[12]=Geom::Point3d.new((x+dxf)+(0.5*r),y-(0.866*r),z)
		@ptd[13]=Geom::Point3d.new((x+dxf)+(0.866*r),y-(0.5*r),z)   
		#Debug @pt.each {|e| UI.messagebox("point = "+ e.to_s)}    
	end #points_LTenon

  def draw_LTenon(entities)
    x=0; y=0; z=0; r=@thickness/2; pp=@lt_length/2
    points_LTenon(x,y,z,r,@xf) #@pt
    #@ptd=@ptd.collect {|point| point.transform(backt)} #Transform to Comp 1
    #@ptd=@ptd.collect {|point| point.transform(@tform)} #Transform to Global
    #Add Tenons
    dface=entities.add_face(@ptd) 
    dface.pushpull(-1*pp)
    dface.pushpull(pp)
  end # draw_LTenon
	
    
	def onMouseMove(flags, x, y, view)
		Sketchup::set_status_text("Select 1st Component for Loose Tenon Joint:    [SPACE BAR] to Exit", SB_PROMPT) if @status==0 
		Sketchup::set_status_text("Select 2nd Component for joint:   [SPACE BAR] to Exit", SB_PROMPT) if @status==1
		Sketchup::set_status_text("Select First Edge in component 1 Parallel to Tenon Width:   [SPACE BAR] to Exit",SB_PROMPT) if @status==2
		Sketchup::set_status_text("Select Second Edge in component 1 90 degrees to First Edge (defines End to CL):   [SPACE BAR] to Exit",SB_PROMPT) if @status==3
		@ip.pick view,x,y
		view.tooltip = @ip.tooltip     
		view.refresh
	end
	
	def onLButtonDown(flags, x, y, view)
		if @status==0 #select 1st component
			ph=view.pick_helper; ph.do_pick x,y; @comp1=ph.best_picked
			if @comp1 && (@comp1.is_a?(Sketchup::ComponentInstance))
				@sel.add(@comp1); @ent1=@comp1.definition.entities;@c1_layer = @comp1.layer
				@status=1; 
				onMouseMove(flags, x, y, view)
			else
				UI.messagebox "Selection invalid, must be component"
			end # if@comp1			
		elsif @status==1	#select 2nd component
			ph=view.pick_helper; ph.do_pick x,y; @comp2=ph.best_picked
			if @comp2 && (@comp2.is_a?(Sketchup::ComponentInstance))
				@sel.add(@comp2); @ent2=@comp2.definition.entities;  @status=2
				@tform2 = @comp2.transformation.inverse
				onMouseMove(flags, x, y, view)
				@sel.clear; @entity=@comp1; @sel.add(@comp1); @comp2.hidden=true
			else
				UI.messagebox "Selection invalid, must be component"
			end #@entity			
		elsif @status==2 #select long edge, width
			@ip.pick view,x,y
			if(@ip.valid?)
				if(@ip.edge && @ent1.include?(@ip.edge))
					@tform = @ip.transformation
					@edge1 = @ip.edge; @e1sp=@edge1.start.position; @e1ep=@edge1.end.position; @e_len1=@edge1.length 
					@status = 3
					onMouseMove(flags, x, y, view)
				else
					UI.messagebox "Selection invalid Use Right Click & Hide Interfering Comp"
				end #if(@ip.edge
			else
				UI.messagebox "Selection invalid "	
			end #if(@ip.valid?)
		elsif @status==3 #select short edge, thickness
			@ip.pick view,x,y
			if(@ip.valid?)
				if(@ip.edge && @ent1.include?(@ip.edge))
					@edge2 = @ip.edge; @e2sp=@edge2.start.position; @e2ep=@edge2.end.position; @e_len2=@edge2.length  
					if @toolType != "SingleComp_Tool" then @comp2.hidden=false end
					if ((@e1sp==@e2sp) || (@e1sp==@e2ep))
						orig=@e1sp
						p1=@e1sp
						p2=@e1ep
					end #if ((@e1sp==
					if ((@e1ep==@e2sp) || (@e1ep==@e2ep))
						orig=@e1ep
						p2=@e1sp
						p1=@e1ep
					end  #if ((@e1ep==
					if orig==@e2sp
						p3=@e2ep
						else
						p3=@e2sp
					end #if orig

          #Data Input Section
          self.same_Joint
          if @use_ExistingData == "No"
            self.select_LooseTenon
            self.data_Input_Form
            self.no_of_Offset_Input
            if @noOffsets >= 1 then self.input_Offsets end 
            #Debug UI.messagebox("Program Stops Here: " + @noOffsets) #Error stops pgm
          else
            begin
              self.readExistingData
            rescue
              UI.messagebox("Problem reading data! ReEnter Data")
              self.select_LooseTenon
              self.data_Input_Form
              self.no_of_Offset_Input
              if @noOffsets >= 1 then self.input_Offsets end
              Debug UI.messagebox("Program Stops Here: " + @noOffsets) #Error stops pgm
              @noOffsets
            end # begin
          end # if @use_ExistingData

          
					#find face that has edges 1 and 2
					face=@edge1.common_face @edge2
					if (face==nil)#14                    #get valid face
						@oops=4
					else 
						#Debug UI.messagebox"got valid face"
						#get points in local coord system for face
						#xaxis parallel to @edge1
						x,y,z=face.normal.axes
						#get vector parallel to @edge1              			         			          
						ar=[p2.x-p1.x,p2.y-p1.y,p2.z-p1.z]
						xx=ar.normalize
						yy=z.cross xx
						localt=Geom::Transformation.axes(orig,xx,yy,z).invert!
						backt=Geom::Transformation.axes(orig,xx,yy,z)
						edges=face.outer_loop.edges
						eind=edges.index(@edge1)
						e_len=@edge1.length
						#Points on face in local coordinates
						p1=p1.transform(localt)
						p2=p2.transform(localt)
						p3=p3.transform(localt)           
						x1=p1.x
						x2=p2.x
						y1=p1.y
						y2=p3.y
						if x1>x2 then dir_x = -1 end
						if x1<x2 then dir_x = +1 end
						if y1<y2 then dir_y = +1 end
						if y1>y2 then dir_y = -1 end
						   		        
						# Options for Complete Joint or Each Part of the Joint
            select_Tool_Options
            if @add_LTSlots_Comp1 == "Yes"
              i=0
              n=@quanity
              Sketchup.active_model.start_operation "LT Slot Comp1"
              while n > 0
                ycl = y1+(@edge2CL*dir_y)
                r=@thickness/2 #radius of LTenon & Mortise
                self.cal_xCL_points(x1,e_len,dir_x)  # @xcl=Array.new @quanity
                #Calculate points for Loose Tenon Mortise Face							
                points_MortiseRd(@xcl[i],ycl,0,r)
                #Calculate points for CLPoint of LTenon Mortise Face
                #Transform LTenon Mortise Face Points to Component 1 Coordinates
                @pt=@pt.collect {|point| point.transform(backt)}
                #Add LTenon Mortise Face
                @comp1.hidden=false
                @entity=@comp1
                codef=@entity.definition
                @sel.clear
                @sel.add(@comp1)
                cface=codef.entities.add_face(@pt) #Fixed array so it uses all elements!
                cface.pushpull(-1*@mdC1)
                #Feature added to First component at this point
                i=i+1
                n=n-1
              end #while n > 0
              # Loose Tenon Slots Added to Comp1 at this Point
              Sketchup.active_model.commit_operation
            end # add_LTSlots_Comp1   
              
            if @add_LTSlots_Comp2 == "Yes"
              i=0
              n=@quanity
              Sketchup.active_model.start_operation "LT Slot Comp1"
              while n > 0
                ycl = y1+(@edge2CL*dir_y)
                r=@thickness/2 #radius of LTenon & Mortise
                self.cal_xCL_points(x1,e_len,dir_x)  # @xcl=Array.new @quanity
                #Calculate points for Loose Tenon Mortise Face							
                points_MortiseRd(@xcl[i],ycl,0,r)
                #Calculate points for CLPoint of LTenon Mortise Face
                #Transform LTenon Mortise Face Points to Component 1 Coordinates
                @pt=@pt.collect {|point| point.transform(backt)}
								@entity=@comp2
								codef=@entity.definition
								@sel.clear
								@sel.add(@comp2)
								@statusstring= "Adding Feature to Second Component"
								Sketchup::set_status_text @statusstring,SB_PROMPT                            	            
								@ptg=@pt.collect {|point| point.transform(@tform)}
								#Debug @ptg.each {|e| UI.messagebox("point c1g = "+ e.to_s)}
								@ptC2=@ptg.collect {|point| point.transform(@tform2)}
								#Debug @clptC2.each {|e| UI.messagebox("CL point c2 = "+ e.to_s)}	            
								cface=codef.entities.add_face(@ptC2)
								cface.pushpull(-1*@mdC2)
							i=i+1
							n=n-1
						end #while n > 0
            # Loose Tenon Slots Added to Comp1 at this Point
						Sketchup.active_model.commit_operation
					end # add_LTSlots_Comp2
          
            if @addLooseTenons == "Yes"
              @sel.clear
              Sketchup.active_model.start_operation "Add LTenons"
              model = Sketchup.active_model
              entities = model.active_entities
              definitions = model.definitions
              layers = model.layers
              group = entities.add_group
              entities = group.entities
              lt_name
              @lt_exist = "no"
              find_LTComp(model,entities,definitions)
              if @lt_exist == "no" #loose tenon component does not exist
                draw_LTenon(entities) #Adds LTenon @(0,0,0)
                component_instance=group.to_component
                component_instance.definition.name=(@lt_name)
                definition = component_instance.definition
              else
                definition = @lt_definition
              end
              i=0
              n=@quanity
              while n > 0
                ycl = y1+(@edge2CL*dir_y)
                r=@thickness/2 #radius of LTenon & Mortise
                self.cal_xCL_points(x1,e_len,dir_x)  # @xcl=Array.new @quanity
                #Calculate z for correct LTenon position
                if @d_Comp1 != @lt_length/2
                  tenon_z = (@lt_length/2) - @d_Comp1
                else
                  tenon_z = 0
                end #if @c2depth 
                #Calculate CL of Hole
                l_tenon_ip=Geom::Point3d.new([@xcl[i],ycl,tenon_z])								
                l_tenon_ip=l_tenon_ip.transform(backt)					
                l_tenon_ip=l_tenon_ip.transform(@tform)
                #Get points for tenon axis at center of hole
                points_LT_CL(@xcl[i],ycl)
                @clpt=@clpt.collect {|point| point.transform(backt)}
                @clpt=@clpt.collect {|point| point.transform(@tform)}
                #Debug @clpt.each {|e| UI.messagebox("CL point c2 = "+ e.to_s)}
                #Create vectors for tenon axis
                x_vector = @clpt[0].vector_to @clpt[1]
                y_vector = @clpt[0].vector_to @clpt[2]
                z_vector = @clpt[0].vector_to @clpt[3]
                #Invoke Geom::Transformation.axes with the new origin, x-axis, y-axis, and z-axis
                f_tran = Geom::Transformation.axes(l_tenon_ip,x_vector,y_vector,z_vector)
                #For i = 0 move existing component to first hole!
                if i == 0 && @lt_exist == "no"
                  #Debug UI.messagebox("f_tran = " + f_tran.to_s)
                  component_instance.transform! f_tran
                  component_instance.layer = @c1_layer
                else
                  if i == 0 then instance2=model.active_entities.add_instance(definition,f_tran) end
                  if i == 0 then instance2.layer = @c1_layer end
                end
                #For i > 0 Insert new instance of L_Tenon at L_Tenon axis origin
                if i > 0 then instance2=model.active_entities.add_instance(definition,f_tran) end
                if i > 0 then instance2.layer = @c1_layer end
                i=i+1
                n=n-1
              end #while
              #Loose Tenons added to Joint at this Point
              Sketchup.active_model.commit_operation
						end # addLooseTenons
						#Program is Complete and ends
						Sketchup.send_action "selectSelectionTool:"
					end #face==nil                        
				end	#if(@ip.edge &&
			else
				UI.messagebox "Selection invalid"	
			end #if(@ip.valid?)	
		end #elsif @status==
	end # def onLButtonDown
	
	def onRButtonDown(flags,x,y,view)
		reset
		self.dialog
		self.no_of_Offset_Input
		if @noOffsets >= 1
			input_Offsets
		end
	end

	def onCancel(flag, view)
		view.refresh if @drawn
		Sketchup.send_action "selectSelectionTool:"
	end

	def draw(view)
		@drawn = false
		if( @ip.valid? && @ip.display? )
			@ip.draw(view)
			@drawn = true
		end
	end
	
end #end class K2_LooseTennonJointTool


 
end #module

 file_loaded("K2_ToolsLooseTenon.rb")
 
