#
#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
  #portions of this code are modifications of examples from Google
  # Copyright 2005-2007, Google, Inc.
  # 
  # Name :        K2_ToolsM_TJoint.rb ###
  # Date :	      July 2014 
  # Version :     2.1.0
  #
  # Author :       Keith Krueger (with a big help from plugin forum:
  #
 
require 'sketchup.rb'
require 'K2WS_Tools/k2ws_module.rb' #-NameSpace Module

module K²WS
 
class K2_M_T_Joint  
    
	def initialize
		@mod = Sketchup.active_model
    @sel = @mod.selection
    @opt_LEN_No = Sketchup.active_model.options["UnitsOptions"]["LengthUnit"]
    @opt_Format_No = Sketchup.active_model.options["UnitsOptions"]["LengthFormat"]
    @opt_Precision_No = Sketchup.active_model.options["UnitsOptions"]["LengthPrecision"]
    @ans=Array.new
    #Test for Acceptable Units/Format and Set rnd_Factor
    @rnd_Factor = 0
    if @opt_LEN_No == 0 && @opt_Format_No == 0 then @rnd_Factor = 10**-(1*@opt_Precision_No) end
    if @opt_LEN_No == 0 && @opt_Format_No == 3 then @rnd_Factor = 0.015625 * 2**(6 - @opt_Precision_No) end
    if @opt_LEN_No == 2 && @opt_Format_No == 0 then @rnd_Factor = 0.0393701 * 10**-(1*@opt_Precision_No) end
    if @rnd_Factor == 0
      UI.messagebox("Units must be Inches or Millimeters \n Fromat must be Decimal or Fractions \n \n CHANGE UNITS & RE-SELECT TOOL ")
      Sketchup.send_action "selectSelectionTool:"
    else
      #Debug UI.messagebox("@rnd_Factor = " + @rnd_Factor.to_s)
    end #if @rnd_Factor
		@ip = Sketchup::InputPoint.new
		@inpt = Sketchup::InputPoint.new		
		@tinpt= Sketchup::InputPoint.new
    @ans=Array.new
		@file =  __FILE__.gsub(/.rb$/,'.txt')
		if !(FileTest.exist?(@file)) 
        f = File.new(@file, "w+") 
        f.close
        self.reset
      else
        self.reset
        self.read_data
      end # FileTest
	end # initialize
	
	def reset
		@best = nil; @comp1 = nil; @comp2 = nil; @sel.clear; @status = 0; @drawn = false
    @add_Tenon_Comp1 = "No"; @add_Mortise_Comp2 = "No"
	end
	
	def read_data
		# Read an array of Input Data from the file 
		# open input data file in read mode	       
		f = File.open(@file, "r")    
		@ans = f.readlines
    #strip end of line or file from all data
    @ans = @ans.collect { |data|
      data.strip 
    }
		# Close the file
		f.close		
	end
	
	def write_data
		# Write an array of Input Data to the file
		# open input data file in write mode	       
		f = File.open(@file, "w")
		f.puts @ans
		# Close the file
		f.close
	end
  
  def same_Joint
      begin
        @edge1_Last = @ans[10].to_l; @edge2_Last = @ans[11].to_l
      rescue
        @edge1_Last = 0; @edge2_Last = 0
        #Debug UI.messagebox("blank data error rescued")
      end
     if @e_len1 == @edge1_Last && @e_len2 == @edge2_Last
        result = UI.messagebox('Use Existing M & T Joint Data ???', MB_YESNO)
        if result == 6 
          @use_ExistingData = "Yes" # @use_ExistingData is not Saved (Secesion only data)
        else
          @use_ExistingData = "No"  # @use_ExistingData is not Saved (Secesion only data)
        end # if result
      else
        @use_ExistingData = "No"  # @use_ExistingData is not Saved (Secesion only data)
      end # if @e_len1
      @ans[10] = @e_len1.to_s;  @ans[11] = @e_len2.to_s
      self.write_data
      #Debug UI.messagebox("use_ExistingData = " + @use_ExistingData.to_s)
    end # same_Joint
    
    def readExistingData
		self.read_data
		@edge=@ans[0].to_s
		@todist=@ans[1].to_l                        
    @thickness=@ans[2].to_l  
    @length=@ans[3].to_l  
		@ed1toend=@ans[4].to_l   
		@ed2toend=@ans[5].to_l
    if @edge == "Haunched"
			@haunch=@ans[6].to_s
			@hlength=@ans[7].to_l
    end # if @edge 
    if @toolType != "SingleComp_Tool" 
			@mdepth=@ans[8].to_l
		end # toolType
    @edge1_Last = @ans[10].to_l
    @edge2_Last = @ans[11].to_l
    @use_ExistingData = @ans[12]
    @selected_DataInput = @ans[13]
    @width = @ans[14].to_l
    @thru_Tenon = @ans[15]
    if @edge == "Segmented"
      @no_Segments = @ans[16].to_i
      @sw = @ans[17].to_l
      @sg = (@width - (@sw * @no_Segments)) / (@no_Segments - 1)
    end # if @edge
   
	end #readExistingData
    
    def tenon_Detail
      #User Selects Data Input Form
      prompts =["Joint Face ( READ ONLY ) ","End Shape","Through Tenon?","Select Features to Locate and Define Tenon"]
      defaults = [@e_len2.to_s + " x " + @e_len1.to_s,@ans[0].to_s,@ans[15].to_s,@ans[13].to_s]
      choices = ["","Square|Round|Haunched|Segmented","Yes|No","_1 Shoulder, 1 Cheek, Thickness, Width, Length___|_2 Shoulders, 1 Cheek, Thickness, Length|_Centered, Thickness, Width, Length"]
      results = inputbox prompts, defaults, choices,"Detail Tenon By: "
      if results == false then self.reset end; Sketchup.send_action "selectSelectionTool:"
      @edge=results[1].to_s; @ans[0] = results[1]
      @thru_Tenon = results[2].to_s; @ans[15] = results[2]
      @selected_DataInput = results[3]; @ans[13] = results[3]
      #Debug UI.messagebox("Type of Data Input = " + @selected_DataInput[0,3])
      
    end # tenon_Detail
    
    def data_Input
      #Use one of 3 different input forms 
      if @selected_DataInput[0,4] == "_1 S"
        prompts = ["Joint Face ( READ ONLY ) ","End1 to Tenon ( Sholder1 ) ","Edge1 to Tenon Cheek","Tenon Thickness","Tenon Width","Tenon Length"]
        defaults= [@e_len2.to_s + " x " + @e_len1.to_s,@ans[4].to_s,@ans[1].to_s,@ans[2].to_s,@ans[14].to_s,@ans[3].to_s]
        choices = ["","","","","",""]  
        results = inputbox prompts, defaults, choices, "Input Data for Tenon "
        if results == false then self.reset end; Sketchup.send_action "selectSelectionTool:"
        @ed1toend = results[1].to_l; @ans[4] = results[1]  #Shoulder1
        @todist = results[2].to_l; @ans[1] = results[2] #Edge1 to Cheek
        @thickness = results[3].to_l; @ans[2] = results[3]
        @width = results[4].to_l; @ans[14] = results[4]
        @length = results[5].to_l; @ans[3] = results[5]
        #Calculate other Variables from Input Data
        @ed2toend = (@e_len1 - (@width + @ed1toend)); @ans[5] = @ed2toend.to_s
      
      elsif @selected_DataInput[0,4] == "_2 S"
        prompts = ["Joint Face ( READ ONLY ) ","End1 to Tenon ( Sholder1 ) ","End2 to Tenon ( Sholder2 ) ","Edge1 to Tenon Cheek","Tenon Thickness","Length"]
        defaults= [@e_len2.to_s + " x " + @e_len1.to_s,@ans[4].to_s,@ans[5].to_s,@ans[1].to_s,@ans[2].to_s,@ans[3].to_s]
        choices = ["","","","","",""]  
        results = inputbox prompts, defaults, choices, "Input Data for Tenon "
        if results == false then self.reset end; Sketchup.send_action "selectSelectionTool:"
        @ed1toend = results[1].to_l; @ans[4] = results[1]  #Shoulder1
        @ed2toend = results[2].to_l; @ans[5] = results[2]  #Shoulder2
        @todist = results[3].to_l; @ans[1] = results[3] #Edge1 to Cheek
        @thickness = results[4].to_l; @ans[2] = results[4]
        @length = results[5].to_l; @ans[3] = results[5]
        #Calculate other Variables from Input Data
        @width = (@e_len1 - (@ed2toend + @ed1toend)); @ans[14] = @width.to_s
        
      elsif @selected_DataInput[0,4] == "_Cen"
        prompts = ["Joint Face ( READ ONLY ) ","Tenon Thickness","Tenon Width","Tenon Length"]
        defaults= [@e_len2.to_s + " x " + @e_len1.to_s,@ans[2].to_s,@ans[14].to_s,@ans[3].to_s]
        choices = ["","","",""]  
        results = inputbox prompts, defaults, choices, "Input Data for CENTERED Tenon "
        if results == false then self.reset end; Sketchup.send_action "selectSelectionTool:"
        @thickness = results[1].to_l; @ans[2] = results[1]
        @width = results[2].to_l; @ans[14] = results[2]
        @length = results[3].to_l; @ans[3] = results[3]
        #Calculate other Variables from Input Data
        @ed2toend = ((@e_len1 - @width) / 2); @ans[5] = @ed2toend.to_s
        @ed1toend = ((@e_len1 - @width) / 2); @ans[4] = @ed2toend.to_s
        @todist = ((@e_len2 - @thickness) / 2); @ans[1] = @todist.to_s
        
      end # if @selected_DataInput
      #Through Tenon
      if @thru_Tenon == "No"
        @mdepth = @length
        @ans[8] = @mdepth
      end #if @thru_Tenon
      write_data 
    end #data_Input
	
	def haunchedData
		# open input data file in read mode	       
		self.read_data
		prompts = ["Haunch On","Haunch Length"]
    defaults= [@ans[6].to_s.strip,@ans[7].to_s.strip]              
		choices = ["Shoulder 1|Shoulder 2|Both",""]   
		results = inputbox prompts, defaults, choices, "Haunched Tenon Dim"
		if results == false then self.reset end; Sketchup.send_action "selectSelectionTool:"
		@haunch=results[0]; @ans[6] = results[0]
		@hlength=results[1].to_l; @ans[7] = results[1]
		# Write an array of Input Data to the file
		self.write_data
	end #haunchedData
  
  def SegmentedData
    self.read_data
		prompts = ["Tenon Width ( READ ONLY ) ","Select NO of Segments ","Segment Width"]
    defaults= [@ans[14].to_s,@ans[16].to_s,@ans[17].to_s]              
		choices = ["","2|3",""]   
		results = inputbox prompts, defaults, choices, "Segmented Data"
		if results == false then self.reset end; Sketchup.send_action "selectSelectionTool:"
		@no_Segments = results[1].to_i; @ans[16] = results[1]
		@sw = results[2].to_l; @ans[17] = results[2]
      @sg = (@width - (@sw * @no_Segments)) / (@no_Segments - 1)
      #Debug  UI.messagebox("Calculated Gap = " + @sg.to_s)
		# Write an array of Input Data to the file
		self.write_data
  
  end
	
	def mortiseDepth
		# open input data file in read mode	       
		self.read_data
		prompts = ["Mortise Depth COMPONENT 2 "]
    defaults= [@ans[8].to_s.strip]                
		results = inputbox prompts, defaults, "Mortise Depth COMPONENT 2"
    if results == false then self.reset end; Sketchup.send_action "selectSelectionTool:"
		@mdepth=results[0].to_l; @ans[8] = results[0]
		# open input data file in write mode	       
		self.write_data
	end #mortiseDepth	
  
  def select_Tool_Options
    @add_Tenon_Comp1 = "No"
    @add_Mortise_Comp2 = "No"
    prompts = ["Select Tool Option"]
    defaults= ["Complete Joint"]
    choices = ["Complete Joint|Comp 1 Tenon|Comp 2 Mortise"]
    results = inputbox prompts, defaults, choices, "Select Mortise & Tenon Tool Options"
    if results == false then self.reset end; Sketchup.send_action "selectSelectionTool:"
    case results[0]
      when "Complete Joint"
        @add_Tenon_Comp1 = "Yes"
        @add_Mortise_Comp2 = "Yes"
      when "Comp 1 Tenon"
        @add_Tenon_Comp1 = "Yes"
      when "Comp 2 Mortise"
        @add_Mortise_Comp2 = "Yes"
    end # case results
  end # select_Tool_Options
	
	def points_TenonSq(x1,x2,y1,z,dir_x,dir_y)
    #Debug UI.messagebox("ed1toend = " + @ed1toend.to_s)
		@pt=Array.new 4
		@pt[0]=Geom::Point3d.new(x1+(@ed1toend*dir_x),y1+(@todist*dir_y),z)
		@pt[1]=Geom::Point3d.new(x1+(@ed1toend*dir_x),y1+(@todist+@thickness)*dir_y,z)
		@pt[2]=Geom::Point3d.new(x2-(@ed2toend*dir_x),y1+(@todist+@thickness)*dir_y,z)
		@pt[3]=Geom::Point3d.new(x2-(@ed2toend*dir_x),y1+(@todist*dir_y),z)       
		#Debug @pt.each {|e| UI.messagebox("point = "+ e.to_s)}    
	end #def points_TenonSq 

  def points_Segment1(x1,x2,y1,z,dir_x,dir_y)
		@pts1=Array.new 4
		@pts1[0]=Geom::Point3d.new(x1+(@ed1toend*dir_x),y1+(@todist*dir_y),z)
		@pts1[1]=Geom::Point3d.new(x1+(@ed1toend*dir_x),y1+(@todist+@thickness)*dir_y,z)
		@pts1[2]=Geom::Point3d.new(@pts1[0].x+(@sw*dir_x),y1+(@todist+@thickness)*dir_y,z)
		@pts1[3]=Geom::Point3d.new(@pts1[0].x+(@sw*dir_x),y1+(@todist*dir_y),z)      
		#Debug @pts1.each {|e| UI.messagebox("point = "+ e.to_s)}    
	end #def points_Segment1 
  
  def points_Segment2(x1,x2,y1,z,dir_x,dir_y)
		@pts2=Array.new 4
    @pts2[0]=Geom::Point3d.new(x2-(@ed2toend*dir_x),y1+(@todist*dir_y),z)
    @pts2[1]=Geom::Point3d.new(x2-(@ed2toend*dir_x),y1+(@todist+@thickness)*dir_y,z)
		@pts2[2]=Geom::Point3d.new(@pts2[0].x-(@sw*dir_x),y1+(@todist+@thickness)*dir_y,z)
		@pts2[3]=Geom::Point3d.new(@pts2[0].x-(@sw*dir_x),y1+(@todist*dir_y),z)      
		#Debug @pts2.each {|e| UI.messagebox("point = "+ e.to_s)}    
	end #def points_Segment2 
  
  def points_Segment3(x1,x2,y1,z,dir_x,dir_y)
		@pts3=Array.new 4
		@pts3[0]=Geom::Point3d.new(@pts1[3].x+(@sg*dir_x),y1+(@todist*dir_y),z)
		@pts3[1]=Geom::Point3d.new(@pts1[3].x+(@sg*dir_x),y1+(@todist+@thickness)*dir_y,z)
		@pts3[2]=Geom::Point3d.new(@pts3[0].x+(@sw*dir_x),y1+(@todist+@thickness)*dir_y,z)
		@pts3[3]=Geom::Point3d.new(@pts3[0].x+(@sw*dir_x),y1+(@todist*dir_y),z)       
		#Debug @pts3.each {|e| UI.messagebox("point = "+ e.to_s)}    
	end #def points_Segment3 
    
	def points_TenonRd(x1,x2,y1,z,dir_x,dir_y)
		@pt=Array.new 14
		r=(@thickness/2).to_l
    ed1toCL = @ed1toend + r
    ed2toCL = @ed2toend + r
		@pt[0]=Geom::Point3d.new(x1+(ed1toCL*dir_x),y1+(@todist*dir_y),z)
		@pt[1]=Geom::Point3d.new(@pt[0].x-(0.5*r*dir_x),@pt[0].y+(r-0.866*r)*dir_y,z)
		@pt[2]=Geom::Point3d.new(@pt[0].x-(0.866*r*dir_x),@pt[0].y+(r-0.5*r)*dir_y,z)
		@pt[3]=Geom::Point3d.new(@pt[0].x-(r*dir_x),@pt[0].y+(r*dir_y),z)
		@pt[4]=Geom::Point3d.new(@pt[2].x,@pt[3].y+(0.5*r*dir_y),z)
		@pt[5]=Geom::Point3d.new(@pt[1].x,@pt[3].y+(0.866*r*dir_y),z)
		@pt[6]=Geom::Point3d.new(@pt[0].x,@pt[3].y+(r*dir_y),z)
		@pt[7]=Geom::Point3d.new(x2-(ed2toCL*dir_x),@pt[6].y,z)
		@pt[8]=Geom::Point3d.new(@pt[7].x+(0.5*r*dir_x),@pt[5].y,z)
		@pt[9]=Geom::Point3d.new(@pt[7].x+(0.866*r*dir_x),@pt[4].y,z)
		@pt[10]=Geom::Point3d.new(@pt[7].x+(r*dir_x),@pt[3].y,z)
		@pt[11]=Geom::Point3d.new(@pt[9].x,@pt[2].y,z)
		@pt[12]=Geom::Point3d.new(@pt[8].x,@pt[1].y,z)
		@pt[13]=Geom::Point3d.new(@pt[7].x,@pt[0].y,z)                      
		#Debug @pt.each {|e| UI.messagebox("point = "+ e.to_s)}    
	end #def points_TenonRd
	
	def points_MortiseCL(x1,x2,y1,dir_y)
		@clpt=Array.new 4
		cline=0.03.inch
		x=@ed1toend+((x2-x1-@ed1toend-@ed2toend)/2)
		y=(y1+@todist+(@thickness/2))*dir_y
		@clpt[0]=Geom::Point3d.new(x+(cline),y,0)
		@clpt[1]=Geom::Point3d.new(x,y,0)
		@clpt[2]=Geom::Point3d.new(x,y+(cline),0)
		@clpt[3]=Geom::Point3d.new(x,y,0)
	end #def points_MortiseCL
		
	def points_HaunchedTenon1(x1,x2,y1,z,dir_x,dir_y)
		@pth=Array.new 4
		case @haunch
			when "Shoulder 1"
				@pth[0]=Geom::Point3d.new(x1,y1+(@todist*dir_y),z)
				@pth[1]=Geom::Point3d.new(x1,y1+(@todist+@thickness)*dir_y,z)
				@pth[2]=Geom::Point3d.new(x2-(@ed2toend*dir_x),y1+(@todist+@thickness)*dir_y,z)
				@pth[3]=Geom::Point3d.new(x2-(@ed2toend*dir_x),y1+(@todist*dir_y),z)       
				#Debug @pt.each {|e| UI.messagebox("point = "+ e.to_s)}
			when "Shoulder 2"
				@pth[0]=Geom::Point3d.new(x1+(@ed1toend*dir_x),y1+(@todist*dir_y),z)
				@pth[1]=Geom::Point3d.new(x1+(@ed1toend*dir_x),y1+(@todist+@thickness)*dir_y,z)
				@pth[2]=Geom::Point3d.new(x2,y1+(@todist+@thickness)*dir_y,z)
				@pth[3]=Geom::Point3d.new(x2,y1+(@todist*dir_y),z) 
			when "Both"
				@pth[0]=Geom::Point3d.new(x1,y1+(@todist*dir_y),z)
				@pth[1]=Geom::Point3d.new(x1,y1+(@todist+@thickness)*dir_y,z)
				@pth[2]=Geom::Point3d.new(x2,y1+(@todist+@thickness)*dir_y,z)
				@pth[3]=Geom::Point3d.new(x2,y1+(@todist*dir_y),z)
		end
		#Debug @pth.each {|e| UI.messagebox("point = "+ e.to_s)}
	end #def points_HaunchedTenon1 
	
	def points_HaunchedTenon2(x1,x2,y1,z,dir_x,dir_y)
		@pt=Array.new 4
		@pt[0]=Geom::Point3d.new(x1+(@ed1toend*dir_x),y1+(@todist*dir_y),z)
		@pt[1]=Geom::Point3d.new(x1+(@ed1toend*dir_x),y1+(@todist+@thickness)*dir_y,z)
		@pt[2]=Geom::Point3d.new(x2-(@ed2toend*dir_x),y1+(@todist+@thickness)*dir_y,z)
		@pt[3]=Geom::Point3d.new(x2-(@ed2toend*dir_x),y1+(@todist*dir_y),z)       
		#Debug @pt.each {|e| UI.messagebox("point = "+ e.to_s)}    
	end #def points_HaunchedTenon2 
 
    
	def onMouseMove(flags, x, y, view)
		Sketchup::set_status_text("Select 1st Component for Tenon Joint:  [SPACE BAR] to Exit", SB_PROMPT) if @status==0 
		Sketchup::set_status_text("Select 2nd Component for joint:   [SPACE BAR] to Exit", SB_PROMPT) if @status==1
		Sketchup::set_status_text("Select First Edge in component 1 Parallel to Tenon Width:   [SPACE BAR] to Exit",SB_PROMPT) if @status==2
		Sketchup::set_status_text("Select Second Edge in component 1 90 degrees to First Edge (defines shoulder 1):   [SPACE BAR] to Exit",SB_PROMPT) if @status==3
		@ip.pick view,x,y
		view.tooltip = @ip.tooltip     
		view.refresh
	end
	
	def onLButtonDown(flags, x, y, view)
		if @status==0 #select 1st component
			ph=view.pick_helper; ph.do_pick x,y; @comp1=ph.best_picked
			if @comp1 && (@comp1.is_a?(Sketchup::ComponentInstance))
				@sel.add(@comp1); @ent1=@comp1.definition.entities; @status=1
				onMouseMove(flags, x, y, view)
			else
				UI.messagebox("Selection invalid, must be component")
			end # if@comp1			
		elsif @status==1	#select 2nd component
			ph=view.pick_helper; ph.do_pick x,y; @comp2=ph.best_picked
			if @comp2 && (@comp2.is_a?(Sketchup::ComponentInstance))
				@sel.add(@comp2); @ent2=@comp2.definition.entities;  @status=2
				@tform2 = @comp2.transformation.inverse
				onMouseMove(flags, x, y, view)
				@sel.clear; @entity=@comp1; @sel.add(@comp1); @comp2.hidden=true
			else
				UI.messagebox("Selection invalid, must be component")
			end #@entity			
		elsif @status==2 #select long edge, width
			@ip.pick view,x,y
			if(@ip.valid?)
				if(@ip.edge && @ent1.include?(@ip.edge))
					@tform = @ip.transformation
					@edge1 = @ip.edge; @e1sp=@edge1.start.position; @e1ep=@edge1.end.position; @e_len1=@edge1.length
					@status = 3
					onMouseMove(flags, x, y, view)
				else
					UI.messagebox("Selection invalid ")
				end #if(@ip.edge
			else
				UI.messagebox("Selection invalid Use Right Click & Hide Interfering Comp")	
			end #if(@ip.valid?)
		elsif @status==3 #select short edge, thickness
			@ip.pick view,x,y
			if(@ip.valid?)
				if(@ip.edge && @ent1.include?(@ip.edge))
					@edge2 = @ip.edge; @e2sp=@edge2.start.position; @e2ep=@edge2.end.position; @e_len2=@edge2.length
					if @toolType != "SingleComp_Tool" then @comp2.hidden=false end
					if ((@e1sp==@e2sp) || (@e1sp==@e2ep))
						orig=@e1sp
						p1=@e1sp
						p2=@e1ep
					end #if ((@e1sp==
					if ((@e1ep==@e2sp) || (@e1ep==@e2ep))
						orig=@e1ep
						p2=@e1sp
						p1=@e1ep
					end  #if ((@e1ep==
					if orig==@e2sp
						p3=@e2ep
					else
						p3=@e2sp
					end #if orig 
          
          #Data Input Section
          self.same_Joint
          if @use_ExistingData == "No"
            self.tenon_Detail
            self.data_Input
            if @edge == "Haunched" then self.haunchedData end
            if @edge == "Segmented" then self.SegmentedData end
            if @thru_Tenon == "Yes" then self.mortiseDepth end
          else
            begin
              self.readExistingData
            rescue
              UI.messagebox("Problem reading data! ReEnter Data")
              self.tenon_Detail
              self.data_Input
            end # begin
          end # if @use_ExistingData
          # Data Complete
          
					#find face that has edges 1 and 2
					face=@edge1.common_face @edge2
					if (face==nil)#14                    #get valid face
						UI.messagebox("face not valid")
					else #14
						#Debug UI.messagebox("got valid face")
						#get points in local coord system for face
						#xaxis parallel to @edge1
						x,y,z=face.normal.axes
						#get vector parallel to @edge1               			          
						ar=[p2.x-p1.x,p2.y-p1.y,p2.z-p1.z]
						xx=ar.normalize
						yy=z.cross xx
						localt=Geom::Transformation.axes(orig,xx,yy,z).invert!
						backt=Geom::Transformation.axes(orig,xx,yy,z)
						edges=face.outer_loop.edges
						eind=edges.index(@edge1)
						e_len=@edge1.length
						#Points on face in local coordinates
						p1=p1.transform(localt); p2=p2.transform(localt); p3=p3.transform(localt)			      			                 
						x1=p1.x; x2=p2.x; y1=p1.y; y2=p3.y			      			      			      
						dir_x = +1; if x1>x2 then dir_x = -1 end
						dir_y = +1; if y1>y2 then dir_y = -1 end
            
						#Get points for Tenon in Local Coordinate System & Transform to Comp1
						if @edge == "Square" 
              points_TenonSq(x1,x2,y1,0,dir_x,dir_y) #Returns @pt[] 4 points
              @pt=@pt.collect {|point| point.transform(backt)} #Transform to Comp1
            end #Returns @pt[] 4 points
						if @edge == "Round" 
              points_TenonRd(x1,x2,y1,0,dir_x,dir_y) #Returns @pt[] 12 points
              @pt=@pt.collect {|point| point.transform(backt)} #Transform to Comp1
            end #Returns @pt[] 12 points
						if @edge == "Haunched" 
              points_HaunchedTenon1(x1,x2,y1,0,dir_x,dir_y) #Returns @pth[] 4 points
              @pth=@pth.collect {|point| point.transform(backt)}  #Transform to Comp1
            end 
						if @edge == "Haunched" 
              points_HaunchedTenon2(x1,x2,y1,@hlength,dir_x,dir_y) #Returns @pt[] 4 points
              @pt=@pt.collect {|point| point.transform(backt)}    #Transform to Comp1
            end #@edge == "Haunched"
            if @edge == "Segmented"
              points_Segment1(x1,x2,y1,0,dir_x,dir_y) #Returns 4 points @pts1[0..3] 
              points_Segment2(x1,x2,y1,0,dir_x,dir_y) #Returns 4 points @pts2[0..3]
              points_Segment3(x1,x2,y1,0,dir_x,dir_y) #Returns 4 points @pts3[0..3]
              @pts1=@pts1.collect {|point| point.transform(backt)}  #Transform to Comp1
              @pts2=@pts2.collect {|point| point.transform(backt)}  #Transform to Comp1
              @pts3=@pts3.collect {|point| point.transform(backt)}  #Transform to Comp1 
            end # if @edge == "Segmented"
            
            # Options for Complete Joint or Each Part of the Joint
            select_Tool_Options
            if @add_Tenon_Comp1 == "Yes"
              codef=@comp1.definition
              @sel.clear
              @sel.add(@comp1)
              Sketchup.active_model.start_operation "Add Tenon"
              case @edge
                when "Segmented"
                  cface=codef.entities.add_face(@pts1) 
                  cface.pushpull(@length)
                  cface=codef.entities.add_face(@pts2) 
                  cface.pushpull(@length)
                  if @no_Segments == 3
                    cface=codef.entities.add_face(@pts3) 
                    cface.pushpull(@length)
                  end #if @no_Segments 
                when "Haunched"
                  cface=codef.entities.add_face(@pth)
                  cface.pushpull(@hlength)
                  cface=codef.entities.add_face(@pt)
                  cface.pushpull((@length-@hlength))
                else
                  cface=codef.entities.add_face(@pt) 
                  cface.pushpull(@length)																
              end # case @edge
              # Tenon Added to Component 1 at this Point
              Sketchup.active_model.commit_operation
            end # if @add_Tenon_Comp1
            
            if @add_Mortise_Comp2 == "Yes"
              Sketchup.active_model.start_operation "Add Mortise"
							codef=@comp2.definition
							@sel.clear
							@sel.add(@comp2)
							#Add Mortise
						  case @edge
                when "Segmented"
                  if @no_Segments == 3
                    @pts3=@pts3.collect {|point| point.transform(@tform)}   # To Global
                    @pts3=@pts3.collect {|point| point.transform(@tform2)}  # To Comp 2
                    cface=codef.entities.add_face(@pts3) 
                    cface.pushpull(-1*@mdepth)
                  end #if @no_Segments
                  @pts1=@pts1.collect {|point| point.transform(@tform)}   # To Global
                  @pts1=@pts1.collect {|point| point.transform(@tform2)}  # To Comp 2
                  @pts2=@pts2.collect {|point| point.transform(@tform)}   # To Global
                  @pts2=@pts2.collect {|point| point.transform(@tform2)}  # To Comp 2
                  cface=codef.entities.add_face(@pts1) 
                  cface.pushpull(-1*@mdepth)
                  cface=codef.entities.add_face(@pts2) 
                  cface.pushpull(-1*@mdepth)
                when "Haunched"                 
                  @pth=@pth.collect {|point| point.transform(@tform)}     # To Global
                  @pth=@pth.collect {|point| point.transform(@tform2)}    # To Comp 2
                  @pt=@pt.collect {|point| point.transform(@tform)}       # To Global
                  @pt=@pt.collect {|point| point.transform(@tform2)}      # To Comp 2
                  cface=codef.entities.add_face(@pth)
                  cface.pushpull(-1*@hlength)
                  cface=codef.entities.add_face(@pt)
                  cface.pushpull(-1*(@mdepth-@hlength))
                else
                  @pt=@pt.collect {|point| point.transform(@tform)}   # To Global
                  @pt=@pt.collect {|point| point.transform(@tform2)}  # To Comp 2
                  cface=codef.entities.add_face(@pt) 
                  cface.pushpull(-1*@mdepth)																
              end #case @edge
              # Mortise added to Component 2 at this Point
              Sketchup.active_model.commit_operation
            end #if @add_Mortise_Comp2
						#Program is Complete and ends
						Sketchup.send_action "selectSelectionTool:" 
					end #if(face==nil)
				end #if(@ip.edge
			else
				UI.messagebox("Selection invalid")
			end #if(@ip.valid?)	
		end #elsif @status==
	end # def onLButtonDown
	
	def onCancel(flag, view)
		view.refresh if @drawn
		Sketchup.send_action "selectSelectionTool:"
	end

	def draw(view)
		@drawn = false
		if( @ip.valid? && @ip.display? )
			@ip.draw(view)
			@drawn = true
		end
	end
	
	def onRButtonDown(flags,x,y,view)
		reset
		self.dialog
		if @edge == "Haunched" then self.haunchedData end
		if @toolType != "SingleComp_Tool" then self.mortiseDepth end
	end

end #end class K2_M_T_Joint
 
end #module

 file_loaded("K2_ToolsM_TJoint.rb")
 
